#ifndef EDJE_OBJECT_EO_HH
#define EDJE_OBJECT_EO_HH
#include <Eo.h>

extern "C" {
#include "edje_object.eo.h"
#include "efl_animator.eo.h"
#include "efl_canvas_group.eo.h"
#include "efl_canvas_group_clipped.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_container.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_file.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_interface.eo.h"
#include "efl_part.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_group.eo.hh"
#include "efl_canvas_group_clipped.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_container.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_file.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_interface.eo.hh"
#include "efl_part.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace edje { 
struct Object;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::edje::Object> : ::std::true_type {}; } }

namespace eo_cxx {
namespace edje { 
struct Object {
   bool update_hints_get() const;
   void update_hints_set( ::efl::eolian::in_traits<bool>::type update) const;
   bool mirrored_get() const;
   void mirrored_set( ::efl::eolian::in_traits<bool>::type rtl) const;
    ::efl::eina::string_view language_get() const;
   void language_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type language) const;
   bool animation_get() const;
   void animation_set( ::efl::eolian::in_traits<bool>::type on) const;
   bool play_get() const;
   void play_set( ::efl::eolian::in_traits<bool>::type play) const;
   double scale_get() const;
   bool scale_set( ::efl::eolian::in_traits<double>::type scale) const;
   double base_scale_get() const;
   void text_change_cb_set( ::efl::eolian::in_traits<Edje_Text_Change_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void part_text_cursor_begin_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   void part_text_cursor_line_end_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   bool text_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text_class,  ::efl::eolian::out_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::out_traits<Evas_Font_Size>::type size) const;
   bool text_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text_class,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::in_traits<Evas_Font_Size>::type size) const;
   bool part_text_cursor_coord_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur,  ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   void part_text_cursor_end_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   bool part_text_escaped_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   void item_provider_set( ::efl::eolian::in_traits<Edje_Item_Provider_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void part_text_cursor_line_begin_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   void message_handler_set( ::efl::eolian::in_traits<Edje_Message_Handler_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void size_min_get( ::efl::eolian::out_traits<Evas_Coord>::type minw,  ::efl::eolian::out_traits<Evas_Coord>::type minh) const;
   Edje_Load_Error load_error_get() const;
   void size_max_get( ::efl::eolian::out_traits<Evas_Coord>::type maxw,  ::efl::eolian::out_traits<Evas_Coord>::type maxh) const;
    ::efl::canvas::Object part_external_content_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type content) const;
   bool global_color_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   bool global_color_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   bool color_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   bool color_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   bool size_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type size_class,  ::efl::eolian::out_traits<int>::type minw,  ::efl::eolian::out_traits<int>::type minh,  ::efl::eolian::out_traits<int>::type maxw,  ::efl::eolian::out_traits<int>::type maxh) const;
   bool size_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type size_class,  ::efl::eolian::in_traits<int>::type minw,  ::efl::eolian::in_traits<int>::type minh,  ::efl::eolian::in_traits<int>::type maxw,  ::efl::eolian::in_traits<int>::type maxh) const;
   double transition_duration_factor_get() const;
   void transition_duration_factor_set( ::efl::eolian::in_traits<double>::type scale) const;
    ::efl::eina::iterator< ::efl::eina::string_view> access_part_iterate() const;
   Edje_External_Param_Type part_external_param_type_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type param) const;
   void part_text_select_allow_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type allow) const;
    ::efl::eina::string_view part_state_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<double>::type val_ret) const;
   void* text_markup_filter_callback_del_full( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Markup_Filter_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   bool part_drag_step_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   bool part_drag_step_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<double>::type dx,  ::efl::eolian::out_traits<double>::type dy) const;
   void* part_text_imf_context_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_select_begin( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
    ::efl::eina::string_view part_text_style_user_peek( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void* signal_callback_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Edje_Signal_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   bool part_text_cursor_next( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   void part_text_style_user_push( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
   void part_text_append( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   bool part_geometry_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   void part_text_input_panel_hide( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool part_text_item_geometry_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type item,  ::efl::eolian::out_traits<Evas_Coord>::type cx,  ::efl::eolian::out_traits<Evas_Coord>::type cy,  ::efl::eolian::out_traits<Evas_Coord>::type cw,  ::efl::eolian::out_traits<Evas_Coord>::type ch) const;
   void part_text_select_abort( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void* text_insert_filter_callback_del_full( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Text_Filter_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void part_text_style_user_pop( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_input_panel_imdata_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<void const*>::type data,  ::efl::eolian::in_traits<int>::type len) const;
   void part_text_insert( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   void part_text_cursor_copy( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type src,  ::efl::eolian::in_traits<Edje_Cursor>::type dst) const;
   bool parts_extends_calc( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   bool part_drag_value_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   bool part_drag_value_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<double>::type dx,  ::efl::eolian::out_traits<double>::type dy) const;
   void calc_force() const;
   void part_text_cursor_pos_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur,  ::efl::eolian::in_traits<int>::type pos) const;
   int part_text_cursor_pos_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   int freeze() const;
   void part_text_input_panel_layout_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Panel_Layout>::type layout) const;
   Edje_Input_Panel_Layout part_text_input_panel_layout_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_input_panel_language_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Panel_Lang>::type lang) const;
   Edje_Input_Panel_Lang part_text_input_panel_language_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
    ::efl::canvas::Object part_external_object_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool preload( ::efl::eolian::in_traits<bool>::type cancel) const;
   void part_text_input_panel_enabled_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type enabled) const;
   bool part_text_input_panel_enabled_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_select_extend( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool part_text_cursor_down( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   bool part_drag_page_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   bool part_drag_page_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<double>::type dx,  ::efl::eolian::out_traits<double>::type dy) const;
   void signal_emit( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source) const;
   void part_text_input_panel_layout_variation_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<int>::type variation) const;
   int part_text_input_panel_layout_variation_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void message_send( ::efl::eolian::in_traits<Edje_Message_Type>::type type,  ::efl::eolian::in_traits<int>::type id,  ::efl::eolian::in_traits<void*>::type msg) const;
   void part_text_select_none( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
    ::efl::canvas::Object part_object_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool part_drag_size_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<double>::type dw,  ::efl::eolian::in_traits<double>::type dh) const;
   bool part_drag_size_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<double>::type dw,  ::efl::eolian::out_traits<double>::type dh) const;
   void* text_insert_filter_callback_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Text_Filter_Cb>::type func) const;
   Edje_Drag_Dir part_drag_dir_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool part_text_unescaped_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text_to_escape) const;
   void signal_callback_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Edje_Signal_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void part_text_select_all( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_input_panel_return_key_disabled_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type disabled) const;
   bool part_text_input_panel_return_key_disabled_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_autocapital_type_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Text_Autocapital_Type>::type autocapital_type) const;
   Edje_Text_Autocapital_Type part_text_autocapital_type_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_prediction_allow_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type prediction) const;
   bool part_text_prediction_allow_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
    ::efl::eina::string_view data_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   void text_markup_filter_callback_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Markup_Filter_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void message_signal_process() const;
   int thaw() const;
   void part_text_imf_context_reset( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_input_panel_return_key_type_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Panel_Return_Key_Type>::type return_key_type) const;
   Edje_Input_Panel_Return_Key_Type part_text_input_panel_return_key_type_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool part_external_param_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<Edje_External_Param>::type param) const;
   void size_min_calc( ::efl::eolian::out_traits<Evas_Coord>::type minw,  ::efl::eolian::out_traits<Evas_Coord>::type minh) const;
   void size_min_restricted_calc( ::efl::eolian::out_traits<Evas_Coord>::type minw,  ::efl::eolian::out_traits<Evas_Coord>::type minh,  ::efl::eolian::in_traits<Evas_Coord>::type restrictedw,  ::efl::eolian::in_traits<Evas_Coord>::type restrictedh) const;
   bool part_drag_page( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   bool part_text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
    ::efl::eina::string_view part_text_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_input_panel_show_on_demand_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type ondemand) const;
   bool part_text_input_panel_show_on_demand_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_input_hint_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Hints>::type input_hints) const;
   Edje_Input_Hints part_text_input_hint_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
    ::efl::eina::string_view part_text_selection_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool part_text_cursor_is_format_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   void text_class_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text_class) const;
    ::efl::eina::string_view color_class_description_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class) const;
   bool color_class_clear() const;
   void color_class_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class) const;
   void size_class_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type size_class) const;
   bool part_drag_step( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   bool part_text_cursor_up( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   void part_text_cursor_geometry_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
     ::efl::eina::range_list< ::efl::eina::string_view> part_text_anchor_list_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void text_insert_filter_callback_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Text_Filter_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void part_text_input_panel_show( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool part_exists( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void* text_markup_filter_callback_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Markup_Filter_Cb>::type func) const;
   bool part_text_cursor_is_visible_format_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   void part_text_user_insert( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   bool part_text_cursor_prev( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
     ::efl::eina::range_list< ::efl::eina::string_view> part_text_item_list_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   static Eo_Class const* _eo_class()
   {
      return EDJE_OBJECT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::edje::Object() const;
   operator ::edje::Object&();
   operator ::edje::Object const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Object,  ::efl::Animator,  ::efl::Container,  ::efl::File,  ::efl::Gfx,  ::efl::Part,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::canvas::group::Clipped,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Object const ,  ::efl::Animator const ,  ::efl::Container const ,  ::efl::File const ,  ::efl::Gfx const ,  ::efl::Part const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::canvas::group::Clipped const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace edje { 
struct Object : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Container)
   , EO_CXX_INHERIT( ::efl::File)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl::Part)
   , EO_CXX_INHERIT( ::efl ::canvas::Group)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::canvas ::group::Clipped)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Object( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Object(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Object(Object const& other) = default;
   Object(Object&& other) = default;
   Object& operator=(Object const& other) = default;
   Object& operator=(Object&& other) = default;
   Object()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Object( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Object(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   bool update_hints_get() const;
   void update_hints_set( ::efl::eolian::in_traits<bool>::type update) const;
   bool mirrored_get() const;
   void mirrored_set( ::efl::eolian::in_traits<bool>::type rtl) const;
    ::efl::eina::string_view language_get() const;
   void language_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type language) const;
   bool animation_get() const;
   void animation_set( ::efl::eolian::in_traits<bool>::type on) const;
   bool play_get() const;
   void play_set( ::efl::eolian::in_traits<bool>::type play) const;
   double scale_get() const;
   bool scale_set( ::efl::eolian::in_traits<double>::type scale) const;
   double base_scale_get() const;
   void text_change_cb_set( ::efl::eolian::in_traits<Edje_Text_Change_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void part_text_cursor_begin_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   void part_text_cursor_line_end_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   bool text_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text_class,  ::efl::eolian::out_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::out_traits<Evas_Font_Size>::type size) const;
   bool text_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text_class,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::in_traits<Evas_Font_Size>::type size) const;
   bool part_text_cursor_coord_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur,  ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   void part_text_cursor_end_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   bool part_text_escaped_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   void item_provider_set( ::efl::eolian::in_traits<Edje_Item_Provider_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void part_text_cursor_line_begin_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   void message_handler_set( ::efl::eolian::in_traits<Edje_Message_Handler_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void size_min_get( ::efl::eolian::out_traits<Evas_Coord>::type minw,  ::efl::eolian::out_traits<Evas_Coord>::type minh) const;
   Edje_Load_Error load_error_get() const;
   void size_max_get( ::efl::eolian::out_traits<Evas_Coord>::type maxw,  ::efl::eolian::out_traits<Evas_Coord>::type maxh) const;
    ::efl::canvas::Object part_external_content_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type content) const;
   bool global_color_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   bool global_color_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   bool color_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   bool color_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   bool size_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type size_class,  ::efl::eolian::out_traits<int>::type minw,  ::efl::eolian::out_traits<int>::type minh,  ::efl::eolian::out_traits<int>::type maxw,  ::efl::eolian::out_traits<int>::type maxh) const;
   bool size_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type size_class,  ::efl::eolian::in_traits<int>::type minw,  ::efl::eolian::in_traits<int>::type minh,  ::efl::eolian::in_traits<int>::type maxw,  ::efl::eolian::in_traits<int>::type maxh) const;
   double transition_duration_factor_get() const;
   void transition_duration_factor_set( ::efl::eolian::in_traits<double>::type scale) const;
    ::efl::eina::iterator< ::efl::eina::string_view> access_part_iterate() const;
   Edje_External_Param_Type part_external_param_type_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type param) const;
   void part_text_select_allow_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type allow) const;
    ::efl::eina::string_view part_state_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<double>::type val_ret) const;
   void* text_markup_filter_callback_del_full( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Markup_Filter_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   bool part_drag_step_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   bool part_drag_step_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<double>::type dx,  ::efl::eolian::out_traits<double>::type dy) const;
   void* part_text_imf_context_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_select_begin( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
    ::efl::eina::string_view part_text_style_user_peek( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void* signal_callback_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Edje_Signal_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   bool part_text_cursor_next( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   void part_text_style_user_push( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
   void part_text_append( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   bool part_geometry_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   void part_text_input_panel_hide( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool part_text_item_geometry_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type item,  ::efl::eolian::out_traits<Evas_Coord>::type cx,  ::efl::eolian::out_traits<Evas_Coord>::type cy,  ::efl::eolian::out_traits<Evas_Coord>::type cw,  ::efl::eolian::out_traits<Evas_Coord>::type ch) const;
   void part_text_select_abort( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void* text_insert_filter_callback_del_full( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Text_Filter_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void part_text_style_user_pop( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_input_panel_imdata_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<void const*>::type data,  ::efl::eolian::in_traits<int>::type len) const;
   void part_text_insert( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   void part_text_cursor_copy( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type src,  ::efl::eolian::in_traits<Edje_Cursor>::type dst) const;
   bool parts_extends_calc( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   bool part_drag_value_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   bool part_drag_value_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<double>::type dx,  ::efl::eolian::out_traits<double>::type dy) const;
   void calc_force() const;
   void part_text_cursor_pos_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur,  ::efl::eolian::in_traits<int>::type pos) const;
   int part_text_cursor_pos_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   int freeze() const;
   void part_text_input_panel_layout_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Panel_Layout>::type layout) const;
   Edje_Input_Panel_Layout part_text_input_panel_layout_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_input_panel_language_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Panel_Lang>::type lang) const;
   Edje_Input_Panel_Lang part_text_input_panel_language_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
    ::efl::canvas::Object part_external_object_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool preload( ::efl::eolian::in_traits<bool>::type cancel) const;
   void part_text_input_panel_enabled_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type enabled) const;
   bool part_text_input_panel_enabled_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_select_extend( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool part_text_cursor_down( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   bool part_drag_page_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   bool part_drag_page_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<double>::type dx,  ::efl::eolian::out_traits<double>::type dy) const;
   void signal_emit( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source) const;
   void part_text_input_panel_layout_variation_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<int>::type variation) const;
   int part_text_input_panel_layout_variation_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void message_send( ::efl::eolian::in_traits<Edje_Message_Type>::type type,  ::efl::eolian::in_traits<int>::type id,  ::efl::eolian::in_traits<void*>::type msg) const;
   void part_text_select_none( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
    ::efl::canvas::Object part_object_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool part_drag_size_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<double>::type dw,  ::efl::eolian::in_traits<double>::type dh) const;
   bool part_drag_size_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<double>::type dw,  ::efl::eolian::out_traits<double>::type dh) const;
   void* text_insert_filter_callback_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Text_Filter_Cb>::type func) const;
   Edje_Drag_Dir part_drag_dir_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool part_text_unescaped_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text_to_escape) const;
   void signal_callback_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Edje_Signal_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void part_text_select_all( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_input_panel_return_key_disabled_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type disabled) const;
   bool part_text_input_panel_return_key_disabled_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_autocapital_type_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Text_Autocapital_Type>::type autocapital_type) const;
   Edje_Text_Autocapital_Type part_text_autocapital_type_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_prediction_allow_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type prediction) const;
   bool part_text_prediction_allow_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
    ::efl::eina::string_view data_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   void text_markup_filter_callback_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Markup_Filter_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void message_signal_process() const;
   int thaw() const;
   void part_text_imf_context_reset( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_input_panel_return_key_type_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Panel_Return_Key_Type>::type return_key_type) const;
   Edje_Input_Panel_Return_Key_Type part_text_input_panel_return_key_type_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool part_external_param_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<Edje_External_Param>::type param) const;
   void size_min_calc( ::efl::eolian::out_traits<Evas_Coord>::type minw,  ::efl::eolian::out_traits<Evas_Coord>::type minh) const;
   void size_min_restricted_calc( ::efl::eolian::out_traits<Evas_Coord>::type minw,  ::efl::eolian::out_traits<Evas_Coord>::type minh,  ::efl::eolian::in_traits<Evas_Coord>::type restrictedw,  ::efl::eolian::in_traits<Evas_Coord>::type restrictedh) const;
   bool part_drag_page( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   bool part_text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
    ::efl::eina::string_view part_text_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_input_panel_show_on_demand_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type ondemand) const;
   bool part_text_input_panel_show_on_demand_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_input_hint_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Hints>::type input_hints) const;
   Edje_Input_Hints part_text_input_hint_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
    ::efl::eina::string_view part_text_selection_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool part_text_cursor_is_format_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   void text_class_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text_class) const;
    ::efl::eina::string_view color_class_description_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class) const;
   bool color_class_clear() const;
   void color_class_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class) const;
   void size_class_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type size_class) const;
   bool part_drag_step( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   bool part_text_cursor_up( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   void part_text_cursor_geometry_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
     ::efl::eina::range_list< ::efl::eina::string_view> part_text_anchor_list_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void text_insert_filter_callback_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Text_Filter_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void part_text_input_panel_show( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool part_exists( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void* text_markup_filter_callback_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Markup_Filter_Cb>::type func) const;
   bool part_text_cursor_is_visible_format_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
   void part_text_user_insert( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   bool part_text_cursor_prev( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Cursor>::type cur) const;
     ::efl::eina::range_list< ::efl::eina::string_view> part_text_item_list_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   static Eo_Class const* _eo_class()
   {
      return EDJE_OBJECT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct recalc_event
   {
      static Eo_Event_Description const* description()
      { return EDJE_OBJECT_EVENT_RECALC; }
      typedef void parameter_type;
   } const recalc_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Object,  ::efl::Animator,  ::efl::Container,  ::efl::File,  ::efl::Gfx,  ::efl::Part,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::canvas::group::Clipped,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Object const ,  ::efl::Animator const ,  ::efl::Container const ,  ::efl::File const ,  ::efl::Gfx const ,  ::efl::Part const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::canvas::group::Clipped const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Object) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Object>::value, "");
} 
#include "edje_object.eo.impl.hh"
#endif
