#ifndef ELDBUS_MODEL_OBJECT_EO_HH
#define ELDBUS_MODEL_OBJECT_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_model.eo.h"
#include "eldbus_model_object.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_model.eo.hh"
#include "eo_base.eo.hh"
namespace eldbus { namespace model { 
struct Object;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::eldbus::model::Object> : ::std::true_type {}; } }

namespace eo_cxx {
namespace eldbus { namespace model { 
struct Object {
   int type_get() const;
   void type_set( ::efl::eolian::in_traits<int>::type type) const;
    ::efl::eina::string_view address_get() const;
   void address_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type address) const;
   bool private_get() const;
   void private_set( ::efl::eolian::in_traits<bool>::type private_) const;
    ::efl::eina::string_view bus_get() const;
   void bus_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type bus) const;
    ::efl::eina::string_view path_get() const;
   void path_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   void constructor( ::efl::eolian::in_traits<int>::type type,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type address,  ::efl::eolian::in_traits<bool>::type private_,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type bus,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   static Eo_Class const* _eo_class()
   {
      return ELDBUS_MODEL_OBJECT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::eldbus::model::Object() const;
   operator ::eldbus::model::Object&();
   operator ::eldbus::model::Object const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Object,  ::efl::Model,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Object const ,  ::efl::Model const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace eldbus { namespace model { 
struct Object : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Model)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Object( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Object(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Object(Object const& other) = default;
   Object(Object&& other) = default;
   Object& operator=(Object const& other) = default;
   Object& operator=(Object&& other) = default;
   Object()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Object( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Object(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   int type_get() const;
   void type_set( ::efl::eolian::in_traits<int>::type type) const;
    ::efl::eina::string_view address_get() const;
   void address_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type address) const;
   bool private_get() const;
   void private_set( ::efl::eolian::in_traits<bool>::type private_) const;
    ::efl::eina::string_view bus_get() const;
   void bus_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type bus) const;
    ::efl::eina::string_view path_get() const;
   void path_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   void constructor( ::efl::eolian::in_traits<int>::type type,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type address,  ::efl::eolian::in_traits<bool>::type private_,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type bus,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   static Eo_Class const* _eo_class()
   {
      return ELDBUS_MODEL_OBJECT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Object,  ::efl::Model,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Object const ,  ::efl::Model const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Object) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Object>::value, "");
} } 
#include "eldbus_model_object.eo.impl.hh"
#endif
