#ifndef ELM_APP_SERVER_VIEW_EO_HH
#define ELM_APP_SERVER_VIEW_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_canvas_object.eo.h"
#include "elm_app_server_view.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_canvas_object.eo.hh"
#include "eo_base.eo.hh"
namespace elm { namespace app { namespace server { 
struct View;
} } } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::app::server::View> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { namespace app { namespace server { 
struct View {
   short progress_get() const;
   void progress_set( ::efl::eolian::in_traits<short>::type progress) const;
   int new_events_get() const;
   void new_events_set( ::efl::eolian::in_traits<int>::type events) const;
    ::efl::eina::string_view icon_get() const;
   void icon_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type icon) const;
    ::efl::eina::string_view title_get() const;
   void title_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type title) const;
   void window_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type win) const;
    ::efl::eina::string_view id_get() const;
   void id_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type ret) const;
   Elm_App_View_State state_get() const;
    ::efl::eina::string_view path_get() const;
   void pause() const;
   void resume() const;
   void shallow() const;
   void close() const;
   static Eo_Class const* _eo_class()
   {
      return ELM_APP_SERVER_VIEW_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::app::server::View() const;
   operator ::elm::app::server::View&();
   operator ::elm::app::server::View const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<View,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<View const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } } 
}
namespace elm { namespace app { namespace server { 
struct View : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit View( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit View(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   View(View const& other) = default;
   View(View&& other) = default;
   View& operator=(View const& other) = default;
   View& operator=(View&& other) = default;
   View()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   View( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> View(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   short progress_get() const;
   void progress_set( ::efl::eolian::in_traits<short>::type progress) const;
   int new_events_get() const;
   void new_events_set( ::efl::eolian::in_traits<int>::type events) const;
    ::efl::eina::string_view icon_get() const;
   void icon_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type icon) const;
    ::efl::eina::string_view title_get() const;
   void title_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type title) const;
   void window_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type win) const;
    ::efl::eina::string_view id_get() const;
   void id_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type ret) const;
   Elm_App_View_State state_get() const;
    ::efl::eina::string_view path_get() const;
   void pause() const;
   void resume() const;
   void shallow() const;
   void close() const;
   static Eo_Class const* _eo_class()
   {
      return ELM_APP_SERVER_VIEW_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct resumed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_SERVER_VIEW_EVENT_RESUMED; }
      typedef void parameter_type;
   } const resumed_event;
   static struct paused_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_SERVER_VIEW_EVENT_PAUSED; }
      typedef void parameter_type;
   } const paused_event;
   static struct closed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_SERVER_VIEW_EVENT_CLOSED; }
      typedef void parameter_type;
   } const closed_event;
   static struct shallow_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_SERVER_VIEW_EVENT_SHALLOW; }
      typedef void parameter_type;
   } const shallow_event;
   static struct save_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_SERVER_VIEW_EVENT_SAVE; }
      typedef void parameter_type;
   } const save_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<View,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<View const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(View) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<View>::value, "");
} } } 
#include "elm_app_server_view.eo.impl.hh"
#endif
