#ifndef ELM_GENLIST_ITEM_EO_HH
#define ELM_GENLIST_ITEM_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_canvas_object.eo.h"
#include "elm_genlist_item.eo.h"
#include "elm_interface_atspi_accessible.eo.h"
#include "elm_interface_atspi_component.eo.h"
#include "elm_widget_item.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_canvas_object.eo.hh"
#include "elm_interface_atspi_accessible.eo.hh"
#include "elm_interface_atspi_component.eo.hh"
#include "elm_widget_item.eo.hh"
#include "eo_base.eo.hh"
namespace elm { namespace genlist { 
struct Item;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::genlist::Item> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { namespace genlist { 
struct Item {
    ::elm::widget::Item prev_get() const;
    ::elm::widget::Item next_get() const;
    ::elm::widget::Item parent_get() const;
     ::efl::eina::range_list< ::elm::widget::Item> subitems_get() const;
   bool selected_get() const;
   void selected_set( ::efl::eolian::in_traits<bool>::type selected) const;
   bool expanded_get() const;
   void expanded_set( ::efl::eolian::in_traits<bool>::type expanded) const;
   int expanded_depth_get() const;
   int index_get() const;
    ::efl::eina::string_view decorate_mode_get() const;
   bool flip_get() const;
   void flip_set( ::efl::eolian::in_traits<bool>::type flip) const;
   Elm_Object_Select_Mode select_mode_get() const;
   void select_mode_set( ::efl::eolian::in_traits<Elm_Object_Select_Mode>::type mode) const;
   Elm_Genlist_Item_Type type_get() const;
    unsigned int subitems_count() const;
   void subitems_clear() const;
   void promote() const;
   void demote() const;
   void show( ::efl::eolian::in_traits<Elm_Genlist_Item_Scrollto_Type>::type type) const;
   void bring_in( ::efl::eolian::in_traits<Elm_Genlist_Item_Scrollto_Type>::type type) const;
   void all_contents_unset( ::efl::eolian::out_traits<  ::efl::eina::list< ::efl::canvas::Object>>::type l) const;
   void update() const;
   void fields_update( ::efl::eolian::in_traits< ::efl::eina::string_view>::type parts,  ::efl::eolian::in_traits<Elm_Genlist_Item_Field_Type>::type itf) const;
   void decorate_mode_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type decorate_it_type,  ::efl::eolian::in_traits<bool>::type decorate_it_set) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_GENLIST_ITEM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::genlist::Item() const;
   operator ::elm::genlist::Item&();
   operator ::elm::genlist::Item const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Item,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::elm::widget::Item,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Item const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::elm::widget::Item const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace elm { namespace genlist { 
struct Item : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Accessible)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Component)
   , EO_CXX_INHERIT( ::elm ::widget::Item)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Item( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Item(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Item(Item const& other) = default;
   Item(Item&& other) = default;
   Item& operator=(Item const& other) = default;
   Item& operator=(Item&& other) = default;
   Item()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Item( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Item(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
    ::elm::widget::Item prev_get() const;
    ::elm::widget::Item next_get() const;
    ::elm::widget::Item parent_get() const;
     ::efl::eina::range_list< ::elm::widget::Item> subitems_get() const;
   bool selected_get() const;
   void selected_set( ::efl::eolian::in_traits<bool>::type selected) const;
   bool expanded_get() const;
   void expanded_set( ::efl::eolian::in_traits<bool>::type expanded) const;
   int expanded_depth_get() const;
   int index_get() const;
    ::efl::eina::string_view decorate_mode_get() const;
   bool flip_get() const;
   void flip_set( ::efl::eolian::in_traits<bool>::type flip) const;
   Elm_Object_Select_Mode select_mode_get() const;
   void select_mode_set( ::efl::eolian::in_traits<Elm_Object_Select_Mode>::type mode) const;
   Elm_Genlist_Item_Type type_get() const;
    unsigned int subitems_count() const;
   void subitems_clear() const;
   void promote() const;
   void demote() const;
   void show( ::efl::eolian::in_traits<Elm_Genlist_Item_Scrollto_Type>::type type) const;
   void bring_in( ::efl::eolian::in_traits<Elm_Genlist_Item_Scrollto_Type>::type type) const;
   void all_contents_unset( ::efl::eolian::out_traits<  ::efl::eina::list< ::efl::canvas::Object>>::type l) const;
   void update() const;
   void fields_update( ::efl::eolian::in_traits< ::efl::eina::string_view>::type parts,  ::efl::eolian::in_traits<Elm_Genlist_Item_Field_Type>::type itf) const;
   void decorate_mode_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type decorate_it_type,  ::efl::eolian::in_traits<bool>::type decorate_it_set) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_GENLIST_ITEM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Item,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::elm::widget::Item,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Item const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::elm::widget::Item const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Item) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Item>::value, "");
} } 
#include "elm_genlist_item.eo.impl.hh"
#endif
