#ifndef ELM_INTERFACE_ATSPI_COMPONENT_EO_HH
#define ELM_INTERFACE_ATSPI_COMPONENT_EO_HH
#include <Eo.h>

extern "C" {
#include "elm_interface_atspi_component.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "eo_base.eo.hh"
namespace elm { namespace interface { 
struct Atspi_Component;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::interface::Atspi_Component> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { namespace interface { 
struct Atspi_Component {
   void size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   bool size_set( ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   int layer_get() const;
   double alpha_get() const;
   int z_order_get() const;
   void extents_get( ::efl::eolian::in_traits<bool>::type screen_coords,  ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y,  ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   bool extents_set( ::efl::eolian::in_traits<bool>::type screen_coords,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   void position_get( ::efl::eolian::in_traits<bool>::type screen_coords,  ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   bool position_set( ::efl::eolian::in_traits<bool>::type screen_coords,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
   bool contains( ::efl::eolian::in_traits<bool>::type screen_coords,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
   bool focus_grab() const;
    ::eo::Base accessible_at_point_get( ::efl::eolian::in_traits<bool>::type screen_coords,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_INTERFACE_ATSPI_COMPONENT_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::interface::Atspi_Component() const;
   operator ::elm::interface::Atspi_Component&();
   operator ::elm::interface::Atspi_Component const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Atspi_Component> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Atspi_Component const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace elm { namespace interface { 
struct Atspi_Component : ::efl::eo::concrete
{
   explicit Atspi_Component( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Atspi_Component(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Atspi_Component(Atspi_Component const& other) = default;
   Atspi_Component(Atspi_Component&& other) = default;
   Atspi_Component& operator=(Atspi_Component const& other) = default;
   Atspi_Component& operator=(Atspi_Component&& other) = default;
   Atspi_Component()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Atspi_Component( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Atspi_Component(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   void size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   bool size_set( ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   int layer_get() const;
   double alpha_get() const;
   int z_order_get() const;
   void extents_get( ::efl::eolian::in_traits<bool>::type screen_coords,  ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y,  ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   bool extents_set( ::efl::eolian::in_traits<bool>::type screen_coords,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   void position_get( ::efl::eolian::in_traits<bool>::type screen_coords,  ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   bool position_set( ::efl::eolian::in_traits<bool>::type screen_coords,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
   bool contains( ::efl::eolian::in_traits<bool>::type screen_coords,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
   bool focus_grab() const;
    ::eo::Base accessible_at_point_get( ::efl::eolian::in_traits<bool>::type screen_coords,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_INTERFACE_ATSPI_COMPONENT_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Atspi_Component> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Atspi_Component const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Atspi_Component) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Atspi_Component>::value, "");
} } 
#include "elm_interface_atspi_component.eo.impl.hh"
#endif
