#ifndef ELM_INTERFACE_FILESELECTOR_EO_HH
#define ELM_INTERFACE_FILESELECTOR_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_model.eo.h"
#include "elm_interface_fileselector.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_model.eo.hh"
namespace elm { namespace interface { 
struct Fileselector;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::interface::Fileselector> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { namespace interface { 
struct Fileselector {
   bool folder_only_get() const;
   void folder_only_set( ::efl::eolian::in_traits<bool>::type only) const;
   void thumbnail_size_get( ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   void thumbnail_size_set( ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h) const;
   bool hidden_visible_get() const;
   void hidden_visible_set( ::efl::eolian::in_traits<bool>::type multi) const;
   Elm_Fileselector_Sort sort_method_get() const;
   void sort_method_set( ::efl::eolian::in_traits<Elm_Fileselector_Sort>::type sort) const;
   bool multi_select_get() const;
   void multi_select_set( ::efl::eolian::in_traits<bool>::type multi) const;
   bool expandable_get() const;
   void expandable_set( ::efl::eolian::in_traits<bool>::type expand) const;
    ::efl::Model model_get() const;
   void model_set( ::efl::eolian::in_traits< ::efl::Model>::type model) const;
   Elm_Fileselector_Mode mode_get() const;
   void mode_set( ::efl::eolian::in_traits<Elm_Fileselector_Mode>::type mode) const;
   bool is_save_get() const;
   void is_save_set( ::efl::eolian::in_traits<bool>::type is_save) const;
     ::efl::eina::range_list< ::efl::Model> selected_models_get() const;
    ::efl::eina::string_view current_name_get() const;
   void current_name_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   void selected_model_set( ::efl::eolian::in_traits< ::efl::Model>::type model,  ::efl::eolian::inout_traits< ::efl::eina::future< ::efl::Model>>::type promise) const;
    ::efl::Model selected_model_get() const;
   bool custom_filter_append( ::efl::eolian::in_traits<Elm_Fileselector_Filter_Func>::type func,  ::efl::eolian::in_traits<void*>::type data,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type filter_name) const;
   void filters_clear() const;
   bool mime_types_filter_append( ::efl::eolian::in_traits< ::efl::eina::string_view>::type mime_types,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type filter_name) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_INTERFACE_FILESELECTOR_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::interface::Fileselector() const;
   operator ::elm::interface::Fileselector&();
   operator ::elm::interface::Fileselector const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Fileselector> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Fileselector const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace elm { namespace interface { 
struct Fileselector : ::efl::eo::concrete
{
   explicit Fileselector( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Fileselector(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Fileselector(Fileselector const& other) = default;
   Fileselector(Fileselector&& other) = default;
   Fileselector& operator=(Fileselector const& other) = default;
   Fileselector& operator=(Fileselector&& other) = default;
   Fileselector()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Fileselector( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Fileselector(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   bool folder_only_get() const;
   void folder_only_set( ::efl::eolian::in_traits<bool>::type only) const;
   void thumbnail_size_get( ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   void thumbnail_size_set( ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h) const;
   bool hidden_visible_get() const;
   void hidden_visible_set( ::efl::eolian::in_traits<bool>::type multi) const;
   Elm_Fileselector_Sort sort_method_get() const;
   void sort_method_set( ::efl::eolian::in_traits<Elm_Fileselector_Sort>::type sort) const;
   bool multi_select_get() const;
   void multi_select_set( ::efl::eolian::in_traits<bool>::type multi) const;
   bool expandable_get() const;
   void expandable_set( ::efl::eolian::in_traits<bool>::type expand) const;
    ::efl::Model model_get() const;
   void model_set( ::efl::eolian::in_traits< ::efl::Model>::type model) const;
   Elm_Fileselector_Mode mode_get() const;
   void mode_set( ::efl::eolian::in_traits<Elm_Fileselector_Mode>::type mode) const;
   bool is_save_get() const;
   void is_save_set( ::efl::eolian::in_traits<bool>::type is_save) const;
     ::efl::eina::range_list< ::efl::Model> selected_models_get() const;
    ::efl::eina::string_view current_name_get() const;
   void current_name_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   void selected_model_set( ::efl::eolian::in_traits< ::efl::Model>::type model,  ::efl::eolian::inout_traits< ::efl::eina::future< ::efl::Model>>::type promise) const;
    ::efl::Model selected_model_get() const;
   bool custom_filter_append( ::efl::eolian::in_traits<Elm_Fileselector_Filter_Func>::type func,  ::efl::eolian::in_traits<void*>::type data,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type filter_name) const;
   void filters_clear() const;
   bool mime_types_filter_append( ::efl::eolian::in_traits< ::efl::eina::string_view>::type mime_types,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type filter_name) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_INTERFACE_FILESELECTOR_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Fileselector> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Fileselector const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Fileselector) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Fileselector>::value, "");
} } 
#include "elm_interface_fileselector.eo.impl.hh"
#endif
