#ifndef ELM_INTERFACE_SCROLLABLE_EO_HH
#define ELM_INTERFACE_SCROLLABLE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas_group.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_interface.eo.h"
#include "efl_ui_scrollable.eo.h"
#include "elm_interface_scrollable.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_group.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_interface.eo.hh"
#include "efl_ui_scrollable.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace elm { 
struct Interface_Scrollable;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::Interface_Scrollable> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { 
struct Interface_Scrollable {
   void gravity_get( ::efl::eolian::out_traits<double>::type x,  ::efl::eolian::out_traits<double>::type y) const;
   void gravity_set( ::efl::eolian::in_traits<double>::type x,  ::efl::eolian::in_traits<double>::type y) const;
   void bounce_allow_get( ::efl::eolian::out_traits<bool>::type horiz,  ::efl::eolian::out_traits<bool>::type vert) const;
   void bounce_allow_set( ::efl::eolian::in_traits<bool>::type horiz,  ::efl::eolian::in_traits<bool>::type vert) const;
   bool wheel_disabled_get() const;
   void wheel_disabled_set( ::efl::eolian::in_traits<bool>::type disabled) const;
   Elm_Scroller_Movement_Block movement_block_get() const;
   void movement_block_set( ::efl::eolian::in_traits<Elm_Scroller_Movement_Block>::type block) const;
   bool momentum_animator_disabled_get() const;
   void momentum_animator_disabled_set( ::efl::eolian::in_traits<bool>::type disabled) const;
   void policy_get( ::efl::eolian::out_traits<Elm_Scroller_Policy>::type hbar,  ::efl::eolian::out_traits<Elm_Scroller_Policy>::type vbar) const;
   void policy_set( ::efl::eolian::in_traits<Elm_Scroller_Policy>::type hbar,  ::efl::eolian::in_traits<Elm_Scroller_Policy>::type vbar) const;
   void content_region_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   void content_region_set( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h) const;
   bool repeat_events_get() const;
   void repeat_events_set( ::efl::eolian::in_traits<bool>::type repeat_events) const;
   void page_size_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y) const;
   void page_size_set( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   bool bounce_animator_disabled_get() const;
   void bounce_animator_disabled_set( ::efl::eolian::in_traits<bool>::type disabled) const;
   void page_scroll_limit_get( ::efl::eolian::out_traits<int>::type page_limit_h,  ::efl::eolian::out_traits<int>::type page_limit_v) const;
   void page_scroll_limit_set( ::efl::eolian::in_traits<int>::type page_limit_h,  ::efl::eolian::in_traits<int>::type page_limit_v) const;
   void page_snap_allow_get( ::efl::eolian::out_traits<bool>::type horiz,  ::efl::eolian::out_traits<bool>::type vert) const;
   void page_snap_allow_set( ::efl::eolian::in_traits<bool>::type horiz,  ::efl::eolian::in_traits<bool>::type vert) const;
   void paging_get( ::efl::eolian::out_traits<double>::type pagerel_h,  ::efl::eolian::out_traits<double>::type pagerel_v,  ::efl::eolian::out_traits<Evas_Coord>::type pagesize_h,  ::efl::eolian::out_traits<Evas_Coord>::type pagesize_v) const;
   void paging_set( ::efl::eolian::in_traits<double>::type pagerel_h,  ::efl::eolian::in_traits<double>::type pagerel_v,  ::efl::eolian::in_traits<Evas_Coord>::type pagesize_h,  ::efl::eolian::in_traits<Evas_Coord>::type pagesize_v) const;
   Elm_Scroller_Single_Direction single_direction_get() const;
   void single_direction_set( ::efl::eolian::in_traits<Elm_Scroller_Single_Direction>::type single_dir) const;
   void step_size_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y) const;
   void step_size_set( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   void loop_get( ::efl::eolian::out_traits<bool>::type loop_h,  ::efl::eolian::out_traits<bool>::type loop_v) const;
   void loop_set( ::efl::eolian::in_traits<bool>::type loop_h,  ::efl::eolian::in_traits<bool>::type loop_v) const;
   void scroll_up_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type scroll_up_cb) const;
   void hbar_drag_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type hbar_drag_cb) const;
   void drag_start_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type drag_start_cb) const;
   void freeze_set( ::efl::eolian::in_traits<bool>::type freeze) const;
   void content_viewport_resize_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Resize_Cb>::type viewport_resize_cb) const;
   void scroll_left_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type scroll_left_cb) const;
   void vbar_press_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type vbar_press_cb) const;
   void hbar_press_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type hbar_press_cb) const;
   void hbar_unpress_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type hbar_unpress_cb) const;
   void drag_stop_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type drag_stop_cb) const;
   void extern_pan_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type pan) const;
   void page_change_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type page_change_cb) const;
   void hold_set( ::efl::eolian::in_traits<bool>::type hold) const;
   void animate_start_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type animate_start_cb) const;
   void scroll_down_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type scroll_down_cb) const;
   void page_relative_set( ::efl::eolian::in_traits<double>::type h_pagerel,  ::efl::eolian::in_traits<double>::type v_pagerel) const;
   void scroll_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type scroll_cb) const;
   void animate_stop_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type animate_stop_cb) const;
   void mirrored_set( ::efl::eolian::in_traits<bool>::type mirrored) const;
   void content_min_limit_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Min_Limit_Cb>::type min_limit_cb) const;
   void scroll_right_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type scroll_right_cb) const;
   void content_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type content) const;
   void edge_left_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type edge_left_cb) const;
   void vbar_drag_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type vbar_drag_cb) const;
   void vbar_unpress_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type vbar_unpress_cb) const;
   void edge_bottom_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type edge_bottom_cb) const;
   void edge_right_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type edge_right_cb) const;
   void edge_top_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type edge_top_cb) const;
   void objects_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type edje_object,  ::efl::eolian::in_traits< ::efl::canvas::Object>::type hit_rectangle) const;
   void last_page_get( ::efl::eolian::out_traits<int>::type pagenumber_h,  ::efl::eolian::out_traits<int>::type pagenumber_v) const;
   void current_page_get( ::efl::eolian::out_traits<int>::type pagenumber_h,  ::efl::eolian::out_traits<int>::type pagenumber_v) const;
   void content_viewport_geometry_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   void content_size_get( ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   void content_pos_set( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<bool>::type sig) const;
   void content_pos_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y) const;
   void page_show( ::efl::eolian::in_traits<int>::type pagenumber_h,  ::efl::eolian::in_traits<int>::type pagenumber_v) const;
   void region_bring_in( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h) const;
   void page_bring_in( ::efl::eolian::in_traits<int>::type pagenumber_h,  ::efl::eolian::in_traits<int>::type pagenumber_v) const;
   void content_region_show( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h) const;
   void content_min_limit( ::efl::eolian::in_traits<bool>::type w,  ::efl::eolian::in_traits<bool>::type h) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_INTERFACE_SCROLLABLE_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::Interface_Scrollable() const;
   operator ::elm::Interface_Scrollable&();
   operator ::elm::Interface_Scrollable const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Interface_Scrollable,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::efl::ui::Scrollable,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Interface_Scrollable const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::efl::ui::Scrollable const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace elm { 
struct Interface_Scrollable : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl ::canvas::Group)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::efl ::ui::Scrollable)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Interface_Scrollable( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Interface_Scrollable(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Interface_Scrollable(Interface_Scrollable const& other) = default;
   Interface_Scrollable(Interface_Scrollable&& other) = default;
   Interface_Scrollable& operator=(Interface_Scrollable const& other) = default;
   Interface_Scrollable& operator=(Interface_Scrollable&& other) = default;
   Interface_Scrollable()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Interface_Scrollable( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Interface_Scrollable(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   void gravity_get( ::efl::eolian::out_traits<double>::type x,  ::efl::eolian::out_traits<double>::type y) const;
   void gravity_set( ::efl::eolian::in_traits<double>::type x,  ::efl::eolian::in_traits<double>::type y) const;
   void bounce_allow_get( ::efl::eolian::out_traits<bool>::type horiz,  ::efl::eolian::out_traits<bool>::type vert) const;
   void bounce_allow_set( ::efl::eolian::in_traits<bool>::type horiz,  ::efl::eolian::in_traits<bool>::type vert) const;
   bool wheel_disabled_get() const;
   void wheel_disabled_set( ::efl::eolian::in_traits<bool>::type disabled) const;
   Elm_Scroller_Movement_Block movement_block_get() const;
   void movement_block_set( ::efl::eolian::in_traits<Elm_Scroller_Movement_Block>::type block) const;
   bool momentum_animator_disabled_get() const;
   void momentum_animator_disabled_set( ::efl::eolian::in_traits<bool>::type disabled) const;
   void policy_get( ::efl::eolian::out_traits<Elm_Scroller_Policy>::type hbar,  ::efl::eolian::out_traits<Elm_Scroller_Policy>::type vbar) const;
   void policy_set( ::efl::eolian::in_traits<Elm_Scroller_Policy>::type hbar,  ::efl::eolian::in_traits<Elm_Scroller_Policy>::type vbar) const;
   void content_region_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   void content_region_set( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h) const;
   bool repeat_events_get() const;
   void repeat_events_set( ::efl::eolian::in_traits<bool>::type repeat_events) const;
   void page_size_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y) const;
   void page_size_set( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   bool bounce_animator_disabled_get() const;
   void bounce_animator_disabled_set( ::efl::eolian::in_traits<bool>::type disabled) const;
   void page_scroll_limit_get( ::efl::eolian::out_traits<int>::type page_limit_h,  ::efl::eolian::out_traits<int>::type page_limit_v) const;
   void page_scroll_limit_set( ::efl::eolian::in_traits<int>::type page_limit_h,  ::efl::eolian::in_traits<int>::type page_limit_v) const;
   void page_snap_allow_get( ::efl::eolian::out_traits<bool>::type horiz,  ::efl::eolian::out_traits<bool>::type vert) const;
   void page_snap_allow_set( ::efl::eolian::in_traits<bool>::type horiz,  ::efl::eolian::in_traits<bool>::type vert) const;
   void paging_get( ::efl::eolian::out_traits<double>::type pagerel_h,  ::efl::eolian::out_traits<double>::type pagerel_v,  ::efl::eolian::out_traits<Evas_Coord>::type pagesize_h,  ::efl::eolian::out_traits<Evas_Coord>::type pagesize_v) const;
   void paging_set( ::efl::eolian::in_traits<double>::type pagerel_h,  ::efl::eolian::in_traits<double>::type pagerel_v,  ::efl::eolian::in_traits<Evas_Coord>::type pagesize_h,  ::efl::eolian::in_traits<Evas_Coord>::type pagesize_v) const;
   Elm_Scroller_Single_Direction single_direction_get() const;
   void single_direction_set( ::efl::eolian::in_traits<Elm_Scroller_Single_Direction>::type single_dir) const;
   void step_size_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y) const;
   void step_size_set( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   void loop_get( ::efl::eolian::out_traits<bool>::type loop_h,  ::efl::eolian::out_traits<bool>::type loop_v) const;
   void loop_set( ::efl::eolian::in_traits<bool>::type loop_h,  ::efl::eolian::in_traits<bool>::type loop_v) const;
   void scroll_up_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type scroll_up_cb) const;
   void hbar_drag_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type hbar_drag_cb) const;
   void drag_start_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type drag_start_cb) const;
   void freeze_set( ::efl::eolian::in_traits<bool>::type freeze) const;
   void content_viewport_resize_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Resize_Cb>::type viewport_resize_cb) const;
   void scroll_left_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type scroll_left_cb) const;
   void vbar_press_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type vbar_press_cb) const;
   void hbar_press_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type hbar_press_cb) const;
   void hbar_unpress_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type hbar_unpress_cb) const;
   void drag_stop_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type drag_stop_cb) const;
   void extern_pan_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type pan) const;
   void page_change_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type page_change_cb) const;
   void hold_set( ::efl::eolian::in_traits<bool>::type hold) const;
   void animate_start_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type animate_start_cb) const;
   void scroll_down_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type scroll_down_cb) const;
   void page_relative_set( ::efl::eolian::in_traits<double>::type h_pagerel,  ::efl::eolian::in_traits<double>::type v_pagerel) const;
   void scroll_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type scroll_cb) const;
   void animate_stop_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type animate_stop_cb) const;
   void mirrored_set( ::efl::eolian::in_traits<bool>::type mirrored) const;
   void content_min_limit_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Min_Limit_Cb>::type min_limit_cb) const;
   void scroll_right_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type scroll_right_cb) const;
   void content_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type content) const;
   void edge_left_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type edge_left_cb) const;
   void vbar_drag_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type vbar_drag_cb) const;
   void vbar_unpress_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type vbar_unpress_cb) const;
   void edge_bottom_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type edge_bottom_cb) const;
   void edge_right_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type edge_right_cb) const;
   void edge_top_cb_set( ::efl::eolian::in_traits<Elm_Interface_Scrollable_Cb>::type edge_top_cb) const;
   void objects_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type edje_object,  ::efl::eolian::in_traits< ::efl::canvas::Object>::type hit_rectangle) const;
   void last_page_get( ::efl::eolian::out_traits<int>::type pagenumber_h,  ::efl::eolian::out_traits<int>::type pagenumber_v) const;
   void current_page_get( ::efl::eolian::out_traits<int>::type pagenumber_h,  ::efl::eolian::out_traits<int>::type pagenumber_v) const;
   void content_viewport_geometry_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   void content_size_get( ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   void content_pos_set( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<bool>::type sig) const;
   void content_pos_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y) const;
   void page_show( ::efl::eolian::in_traits<int>::type pagenumber_h,  ::efl::eolian::in_traits<int>::type pagenumber_v) const;
   void region_bring_in( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h) const;
   void page_bring_in( ::efl::eolian::in_traits<int>::type pagenumber_h,  ::efl::eolian::in_traits<int>::type pagenumber_v) const;
   void content_region_show( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h) const;
   void content_min_limit( ::efl::eolian::in_traits<bool>::type w,  ::efl::eolian::in_traits<bool>::type h) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_INTERFACE_SCROLLABLE_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct changed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_INTERFACE_SCROLLABLE_EVENT_CHANGED; }
      typedef void parameter_type;
   } const changed_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Interface_Scrollable,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::efl::ui::Scrollable,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Interface_Scrollable const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::efl::ui::Scrollable const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Interface_Scrollable) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Interface_Scrollable>::value, "");
} 
#include "elm_interface_scrollable.eo.impl.hh"
#endif
