#ifndef ELM_LAYOUT_EO_HH
#define ELM_LAYOUT_EO_HH
#include <Eo.h>

extern "C" {
#include "edje_object.eo.h"
#include "efl_animator.eo.h"
#include "efl_canvas_group.eo.h"
#include "efl_canvas_group_clipped.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_container.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_file.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_interface.eo.h"
#include "efl_part.eo.h"
#include "elm_interface_atspi_accessible.eo.h"
#include "elm_interface_atspi_component.eo.h"
#include "elm_layout.eo.h"
#include "elm_widget.eo.h"
#include "elm_widget_item.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "edje_object.eo.hh"
#include "efl_animator.eo.hh"
#include "efl_canvas_group.eo.hh"
#include "efl_canvas_group_clipped.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_container.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_file.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_interface.eo.hh"
#include "efl_part.eo.hh"
#include "elm_interface_atspi_accessible.eo.hh"
#include "elm_interface_atspi_component.eo.hh"
#include "elm_widget.eo.hh"
#include "elm_widget_item.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace elm { 
struct Layout;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::Layout> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { 
struct Layout {
   bool edje_object_can_access_get() const;
   bool edje_object_can_access_set( ::efl::eolian::in_traits<bool>::type can_access) const;
   bool theme_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type klass,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type group,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
    ::efl::canvas::Object edje_get() const;
    ::efl::eina::string_view text_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   bool part_cursor_engine_only_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part_name,  ::efl::eolian::in_traits<bool>::type engine_only) const;
   bool part_cursor_engine_only_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part_name) const;
   bool theme_enable() const;
   void sizing_eval() const;
   void sizing_restricted_eval( ::efl::eolian::in_traits<bool>::type width,  ::efl::eolian::in_traits<bool>::type height) const;
   bool part_cursor_style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part_name,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
    ::efl::eina::string_view part_cursor_style_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part_name) const;
   bool part_cursor_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part_name,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type cursor) const;
    ::efl::eina::string_view part_cursor_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part_name) const;
   bool sub_object_add_enable() const;
   bool part_cursor_unset( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part_name) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_LAYOUT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::Layout() const;
   operator ::elm::Layout&();
   operator ::elm::Layout const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Layout,  ::edje::Object,  ::efl::Animator,  ::efl::Container,  ::efl::File,  ::efl::Gfx,  ::efl::Part,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::canvas::group::Clipped,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::elm::Widget,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Layout const ,  ::edje::Object const ,  ::efl::Animator const ,  ::efl::Container const ,  ::efl::File const ,  ::efl::Gfx const ,  ::efl::Part const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::canvas::group::Clipped const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::elm::Widget const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace elm { 
struct Layout : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::edje::Object)
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Container)
   , EO_CXX_INHERIT( ::efl::File)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl::Part)
   , EO_CXX_INHERIT( ::efl ::canvas::Group)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::canvas ::group::Clipped)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::elm::Widget)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Accessible)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Component)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Layout( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Layout(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Layout(Layout const& other) = default;
   Layout(Layout&& other) = default;
   Layout& operator=(Layout const& other) = default;
   Layout& operator=(Layout&& other) = default;
   Layout()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Layout( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Layout(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   bool edje_object_can_access_get() const;
   bool edje_object_can_access_set( ::efl::eolian::in_traits<bool>::type can_access) const;
   bool theme_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type klass,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type group,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
    ::efl::canvas::Object edje_get() const;
    ::efl::eina::string_view text_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   bool text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   bool part_cursor_engine_only_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part_name,  ::efl::eolian::in_traits<bool>::type engine_only) const;
   bool part_cursor_engine_only_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part_name) const;
   bool theme_enable() const;
   void sizing_eval() const;
   void sizing_restricted_eval( ::efl::eolian::in_traits<bool>::type width,  ::efl::eolian::in_traits<bool>::type height) const;
   bool part_cursor_style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part_name,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
    ::efl::eina::string_view part_cursor_style_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part_name) const;
   bool part_cursor_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part_name,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type cursor) const;
    ::efl::eina::string_view part_cursor_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part_name) const;
   bool sub_object_add_enable() const;
   bool part_cursor_unset( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part_name) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_LAYOUT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct theme_changed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_LAYOUT_EVENT_THEME_CHANGED; }
      typedef void parameter_type;
   } const theme_changed_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Layout,  ::edje::Object,  ::efl::Animator,  ::efl::Container,  ::efl::File,  ::efl::Gfx,  ::efl::Part,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::canvas::group::Clipped,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::elm::Widget,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Layout const ,  ::edje::Object const ,  ::efl::Animator const ,  ::efl::Container const ,  ::efl::File const ,  ::efl::Gfx const ,  ::efl::Part const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::canvas::group::Clipped const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::elm::Widget const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Layout) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Layout>::value, "");
} 
#include "elm_layout.eo.impl.hh"
#endif
