#ifndef ELM_TOOLBAR_ITEM_EO_HH
#define ELM_TOOLBAR_ITEM_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_canvas_object.eo.h"
#include "elm_interface_atspi_accessible.eo.h"
#include "elm_interface_atspi_component.eo.h"
#include "elm_toolbar_item.eo.h"
#include "elm_widget_item.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_canvas_object.eo.hh"
#include "elm_interface_atspi_accessible.eo.hh"
#include "elm_interface_atspi_component.eo.hh"
#include "elm_widget_item.eo.hh"
#include "eo_base.eo.hh"
namespace elm { namespace toolbar { 
struct Item;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::toolbar::Item> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { namespace toolbar { 
struct Item {
    ::elm::widget::Item prev_get() const;
    ::elm::widget::Item next_get() const;
   int priority_get() const;
   void priority_set( ::efl::eolian::in_traits<int>::type priority) const;
   bool selected_get() const;
   void selected_set( ::efl::eolian::in_traits<bool>::type selected) const;
    ::efl::eina::string_view icon_get() const;
   void icon_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type icon) const;
    ::efl::canvas::Object object_get() const;
    ::efl::canvas::Object icon_object_get() const;
   bool separator_get() const;
   void separator_set( ::efl::eolian::in_traits<bool>::type separator) const;
    ::efl::canvas::Object menu_get() const;
   bool icon_memfile_set( ::efl::eolian::in_traits<void const*>::type img,  ::efl::eolian::in_traits< size_t>::type size,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type format,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   bool icon_file_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type file,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   void show( ::efl::eolian::in_traits<Elm_Toolbar_Item_Scrollto_Type>::type scrollto) const;
   void bring_in( ::efl::eolian::in_traits<Elm_Toolbar_Item_Scrollto_Type>::type scrollto) const;
   void menu_set( ::efl::eolian::in_traits<bool>::type menu) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_TOOLBAR_ITEM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::toolbar::Item() const;
   operator ::elm::toolbar::Item&();
   operator ::elm::toolbar::Item const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Item,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::elm::widget::Item,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Item const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::elm::widget::Item const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace elm { namespace toolbar { 
struct Item : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Accessible)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Component)
   , EO_CXX_INHERIT( ::elm ::widget::Item)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Item( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Item(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Item(Item const& other) = default;
   Item(Item&& other) = default;
   Item& operator=(Item const& other) = default;
   Item& operator=(Item&& other) = default;
   Item()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Item( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Item(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
    ::elm::widget::Item prev_get() const;
    ::elm::widget::Item next_get() const;
   int priority_get() const;
   void priority_set( ::efl::eolian::in_traits<int>::type priority) const;
   bool selected_get() const;
   void selected_set( ::efl::eolian::in_traits<bool>::type selected) const;
    ::efl::eina::string_view icon_get() const;
   void icon_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type icon) const;
    ::efl::canvas::Object object_get() const;
    ::efl::canvas::Object icon_object_get() const;
   bool separator_get() const;
   void separator_set( ::efl::eolian::in_traits<bool>::type separator) const;
    ::efl::canvas::Object menu_get() const;
   bool icon_memfile_set( ::efl::eolian::in_traits<void const*>::type img,  ::efl::eolian::in_traits< size_t>::type size,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type format,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   bool icon_file_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type file,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   void show( ::efl::eolian::in_traits<Elm_Toolbar_Item_Scrollto_Type>::type scrollto) const;
   void bring_in( ::efl::eolian::in_traits<Elm_Toolbar_Item_Scrollto_Type>::type scrollto) const;
   void menu_set( ::efl::eolian::in_traits<bool>::type menu) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_TOOLBAR_ITEM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Item,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::elm::widget::Item,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Item const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::elm::widget::Item const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Item) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Item>::value, "");
} } 
#include "elm_toolbar_item.eo.impl.hh"
#endif
