#ifndef ELM_WEB_EO_HH
#define ELM_WEB_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas_group.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_interface.eo.h"
#include "elm_interface_atspi_accessible.eo.h"
#include "elm_interface_atspi_component.eo.h"
#include "elm_web.eo.h"
#include "elm_widget.eo.h"
#include "elm_widget_item.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_group.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_interface.eo.hh"
#include "elm_interface_atspi_accessible.eo.hh"
#include "elm_interface_atspi_component.eo.hh"
#include "elm_widget.eo.hh"
#include "elm_widget_item.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace elm { 
struct Web;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::Web> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { 
struct Web {
   bool text_matches_highlight_get() const;
   bool text_matches_highlight_set( ::efl::eolian::in_traits<bool>::type highlight) const;
    ::efl::eina::string_view useragent_get() const;
   void useragent_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type user_agent) const;
    ::efl::eina::string_view url_get() const;
   bool url_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type url) const;
   void bg_color_get( ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   void bg_color_set( ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   bool inwin_mode_get() const;
   void inwin_mode_set( ::efl::eolian::in_traits<bool>::type value) const;
   bool tab_propagate_get() const;
   void tab_propagate_set( ::efl::eolian::in_traits<bool>::type propagate) const;
   bool history_enabled_get() const;
   void history_enabled_set( ::efl::eolian::in_traits<bool>::type enable) const;
   Elm_Web_Zoom_Mode zoom_mode_get() const;
   void zoom_mode_set( ::efl::eolian::in_traits<Elm_Web_Zoom_Mode>::type mode) const;
   double zoom_get() const;
   void zoom_set( ::efl::eolian::in_traits<double>::type zoom) const;
   void console_message_hook_set( ::efl::eolian::in_traits<Elm_Web_Console_Message>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void window_create_hook_set( ::efl::eolian::in_traits<Elm_Web_Window_Open>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void dialog_file_selector_hook_set( ::efl::eolian::in_traits<Elm_Web_Dialog_File_Selector>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void dialog_confirm_hook_set( ::efl::eolian::in_traits<Elm_Web_Dialog_Confirm>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void popup_selected_set( ::efl::eolian::in_traits<int>::type idx) const;
   void dialog_prompt_hook_set( ::efl::eolian::in_traits<Elm_Web_Dialog_Prompt>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void dialog_alert_hook_set( ::efl::eolian::in_traits<Elm_Web_Dialog_Alert>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   bool forward_possible_get() const;
    ::efl::canvas::Object webkit_view_get() const;
   bool back_possible_get() const;
   double load_progress_get() const;
    ::std::string selection_get() const;
    ::std::string title_get() const;
   bool navigate( ::efl::eolian::in_traits<int>::type steps) const;
   bool back() const;
   bool html_string_load( ::efl::eolian::in_traits< ::efl::eina::string_view>::type html,  ::efl::eolian::in_traits< ::efl::eina::optional< ::efl::eina::string_view>>::type base_url,  ::efl::eolian::in_traits< ::efl::eina::optional< ::efl::eina::string_view>>::type unreachable_url) const;
   bool text_search( ::efl::eolian::in_traits< ::efl::eina::string_view>::type string,  ::efl::eolian::in_traits<bool>::type case_sensitive,  ::efl::eolian::in_traits<bool>::type forward,  ::efl::eolian::in_traits<bool>::type wrap) const;
   bool popup_destroy() const;
   void region_show( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   bool forward() const;
    unsigned int text_matches_mark( ::efl::eolian::in_traits< ::efl::eina::string_view>::type string,  ::efl::eolian::in_traits<bool>::type case_sensitive,  ::efl::eolian::in_traits<bool>::type highlight,  ::efl::eolian::in_traits< unsigned int>::type limit) const;
   void region_bring_in( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   bool stop() const;
   bool navigate_possible_get( ::efl::eolian::in_traits<int>::type steps) const;
   bool reload_full() const;
   bool text_matches_unmark_all() const;
   bool reload() const;
   static Eo_Class const* _eo_class()
   {
      return ELM_WEB_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::Web() const;
   operator ::elm::Web&();
   operator ::elm::Web const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Web,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::elm::Widget,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Web const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::elm::Widget const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace elm { 
struct Web : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl ::canvas::Group)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::elm::Widget)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Accessible)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Component)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Web( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Web(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Web(Web const& other) = default;
   Web(Web&& other) = default;
   Web& operator=(Web const& other) = default;
   Web& operator=(Web&& other) = default;
   Web()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Web( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Web(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   bool text_matches_highlight_get() const;
   bool text_matches_highlight_set( ::efl::eolian::in_traits<bool>::type highlight) const;
    ::efl::eina::string_view useragent_get() const;
   void useragent_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type user_agent) const;
    ::efl::eina::string_view url_get() const;
   bool url_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type url) const;
   void bg_color_get( ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   void bg_color_set( ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   bool inwin_mode_get() const;
   void inwin_mode_set( ::efl::eolian::in_traits<bool>::type value) const;
   bool tab_propagate_get() const;
   void tab_propagate_set( ::efl::eolian::in_traits<bool>::type propagate) const;
   bool history_enabled_get() const;
   void history_enabled_set( ::efl::eolian::in_traits<bool>::type enable) const;
   Elm_Web_Zoom_Mode zoom_mode_get() const;
   void zoom_mode_set( ::efl::eolian::in_traits<Elm_Web_Zoom_Mode>::type mode) const;
   double zoom_get() const;
   void zoom_set( ::efl::eolian::in_traits<double>::type zoom) const;
   void console_message_hook_set( ::efl::eolian::in_traits<Elm_Web_Console_Message>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void window_create_hook_set( ::efl::eolian::in_traits<Elm_Web_Window_Open>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void dialog_file_selector_hook_set( ::efl::eolian::in_traits<Elm_Web_Dialog_File_Selector>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void dialog_confirm_hook_set( ::efl::eolian::in_traits<Elm_Web_Dialog_Confirm>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void popup_selected_set( ::efl::eolian::in_traits<int>::type idx) const;
   void dialog_prompt_hook_set( ::efl::eolian::in_traits<Elm_Web_Dialog_Prompt>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void dialog_alert_hook_set( ::efl::eolian::in_traits<Elm_Web_Dialog_Alert>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   bool forward_possible_get() const;
    ::efl::canvas::Object webkit_view_get() const;
   bool back_possible_get() const;
   double load_progress_get() const;
    ::std::string selection_get() const;
    ::std::string title_get() const;
   bool navigate( ::efl::eolian::in_traits<int>::type steps) const;
   bool back() const;
   bool html_string_load( ::efl::eolian::in_traits< ::efl::eina::string_view>::type html,  ::efl::eolian::in_traits< ::efl::eina::optional< ::efl::eina::string_view>>::type base_url,  ::efl::eolian::in_traits< ::efl::eina::optional< ::efl::eina::string_view>>::type unreachable_url) const;
   bool text_search( ::efl::eolian::in_traits< ::efl::eina::string_view>::type string,  ::efl::eolian::in_traits<bool>::type case_sensitive,  ::efl::eolian::in_traits<bool>::type forward,  ::efl::eolian::in_traits<bool>::type wrap) const;
   bool popup_destroy() const;
   void region_show( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   bool forward() const;
    unsigned int text_matches_mark( ::efl::eolian::in_traits< ::efl::eina::string_view>::type string,  ::efl::eolian::in_traits<bool>::type case_sensitive,  ::efl::eolian::in_traits<bool>::type highlight,  ::efl::eolian::in_traits< unsigned int>::type limit) const;
   void region_bring_in( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   bool stop() const;
   bool navigate_possible_get( ::efl::eolian::in_traits<int>::type steps) const;
   bool reload_full() const;
   bool text_matches_unmark_all() const;
   bool reload() const;
   static Eo_Class const* _eo_class()
   {
      return ELM_WEB_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct uri_changed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_WEB_EVENT_URI_CHANGED; }
      typedef void parameter_type;
   } const uri_changed_event;
   static struct url_changed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_WEB_EVENT_URL_CHANGED; }
      typedef void parameter_type;
   } const url_changed_event;
   static struct windows_close_request_event
   {
      static Eo_Event_Description const* description()
      { return ELM_WEB_EVENT_WINDOWS_CLOSE_REQUEST; }
      typedef void parameter_type;
   } const windows_close_request_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Web,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::elm::Widget,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Web const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::elm::Widget const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Web) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Web>::value, "");
} 
#include "elm_web.eo.impl.hh"
#endif
