#ifndef ELM_WIDGET_EO_HH
#define ELM_WIDGET_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas_group.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_interface.eo.h"
#include "elm_interface_atspi_accessible.eo.h"
#include "elm_interface_atspi_component.eo.h"
#include "elm_widget.eo.h"
#include "elm_widget_item.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_group.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_interface.eo.hh"
#include "elm_interface_atspi_accessible.eo.hh"
#include "elm_interface_atspi_component.eo.hh"
#include "elm_widget_item.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace elm { 
struct Widget;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::Widget> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { 
struct Widget {
   bool focus_get() const;
   void focus_set( ::efl::eolian::in_traits<bool>::type focus) const;
   bool drag_lock_y_get() const;
   void drag_lock_y_set( ::efl::eolian::in_traits<bool>::type lock) const;
    ::efl::eina::string_view focus_highlight_style_get() const;
   bool focus_highlight_style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
   bool tree_unfocusable_get() const;
   void tree_unfocusable_set( ::efl::eolian::in_traits<bool>::type tree_unfocusable) const;
   bool mirrored_get() const;
   void mirrored_set( ::efl::eolian::in_traits<bool>::type mirrored) const;
   bool disabled_get() const;
   void disabled_set( ::efl::eolian::in_traits<bool>::type disabled) const;
   bool highlight_ignore_get() const;
   void highlight_ignore_set( ::efl::eolian::in_traits<bool>::type ignore) const;
   bool mirrored_automatic_get() const;
   void mirrored_automatic_set( ::efl::eolian::in_traits<bool>::type automatic) const;
   bool orientation_mode_disabled_get() const;
   void orientation_mode_disabled_set( ::efl::eolian::in_traits<bool>::type disabled) const;
    ::efl::eina::string_view style_get() const;
   Elm_Theme_Apply style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
   double scale_get() const;
   void scale_set( ::efl::eolian::in_traits<double>::type scale) const;
     ::efl::eina::range_list< ::efl::canvas::Object> focus_custom_chain_get() const;
   void focus_custom_chain_set( ::efl::eolian::in_traits<  ::efl::eina::range_list< ::efl::canvas::Object>>::type objs) const;
   bool can_focus_get() const;
   void can_focus_set( ::efl::eolian::in_traits<bool>::type can_focus) const;
   bool highlight_in_theme_get() const;
   void highlight_in_theme_set( ::efl::eolian::in_traits<bool>::type highlight) const;
    ::efl::canvas::Object widget_parent_get() const;
   void widget_parent_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type parent) const;
    ::efl::eina::string_view access_info_get() const;
   void access_info_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type txt) const;
   bool drag_lock_x_get() const;
   void drag_lock_x_set( ::efl::eolian::in_traits<bool>::type lock) const;
   bool access_highlight_in_theme_get() const;
   void access_highlight_in_theme_set( ::efl::eolian::in_traits<bool>::type highlight) const;
   Elm_Focus_Region_Show_Mode focus_region_show_mode_get() const;
   void focus_region_show_mode_set( ::efl::eolian::in_traits<Elm_Focus_Region_Show_Mode>::type mode) const;
   void parent_highlight_set( ::efl::eolian::in_traits<bool>::type highlighted) const;
   Elm_Theme_Apply theme_object_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type edj,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type wname,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type welement,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type wstyle) const;
   void hover_object_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type sobj) const;
   void display_mode_set( ::efl::eolian::in_traits<Efl_Gfx_Size_Hint_Mode>::type dispmode) const;
   void on_show_region_hook_set( ::efl::eolian::in_traits<region_hook_func_type>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void domain_part_text_translatable_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type domain,  ::efl::eolian::in_traits<bool>::type translatable) const;
   void orientation_set( ::efl::eolian::in_traits<int>::type rotation) const;
   void resize_object_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type sobj,  ::efl::eolian::in_traits<bool>::type sub_obj) const;
   void domain_translatable_part_text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type domain,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type label) const;
     ::efl::eina::list< ::efl::canvas::Object> scrollable_children_get() const;
   int scroll_hold_get() const;
   int drag_child_locked_y_get() const;
   bool item_loop_enabled_get() const;
   void item_loop_enabled_set( ::efl::eolian::in_traits<bool>::type enable) const;
   bool child_can_focus_get() const;
   int scroll_freeze_get() const;
   bool focus_region_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
    ::efl::canvas::Object top_get() const;
    unsigned int focus_order_get() const;
   int drag_child_locked_x_get() const;
     ::efl::eina::list< ::efl::canvas::Object> can_focus_child_list_get() const;
    ::elm::widget::Item focused_item_get() const;
   void parents_bounce_get( ::efl::eolian::out_traits<bool>::type horiz,  ::efl::eolian::out_traits<bool>::type vert) const;
    ::efl::canvas::Object parent_widget_get() const;
   bool highlight_get() const;
    ::efl::canvas::Object focused_object_get() const;
    ::efl::canvas::Object parent2_get() const;
   void parent2_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type parent) const;
    ::efl::eina::string_view part_text_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type label) const;
   Efl_Ui_Focus_Move_Policy focus_move_policy_get() const;
   void focus_move_policy_set( ::efl::eolian::in_traits<Efl_Ui_Focus_Move_Policy>::type policy) const;
   bool focus_move_policy_automatic_get() const;
   void focus_move_policy_automatic_set( ::efl::eolian::in_traits<bool>::type automatic) const;
    ::efl::canvas::Object newest_focus_order_get( ::efl::eolian::out_traits< unsigned int>::type newest_focus_order,  ::efl::eolian::in_traits<bool>::type can_focus_only) const;
   void scroll_hold_push() const;
   void focus_next_object_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type next,  ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
    ::efl::canvas::Object focus_next_object_get( ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
   void focus_next_item_set( ::efl::eolian::in_traits< ::elm::widget::Item>::type next_item,  ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
    ::elm::widget::Item focus_next_item_get( ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
   void focus_tree_unfocusable_handle() const;
   void focus_custom_chain_prepend( ::efl::eolian::in_traits< ::efl::canvas::Object>::type child,  ::efl::eolian::in_traits< ::efl::canvas::Object>::type relative_child) const;
    ::efl::eina::string_view part_text_translate( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   void focus_highlight_geometry_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   bool activate( ::efl::eolian::in_traits<Elm_Activate>::type act) const;
   bool sub_object_add( ::efl::eolian::in_traits< ::efl::canvas::Object>::type sobj) const;
   bool focus_direction_manager_is() const;
   bool event( ::efl::eolian::in_traits< ::efl::canvas::Object>::type source,  ::efl::eolian::in_traits<Evas_Callback_Type>::type type,  ::efl::eolian::in_traits<void*>::type event_info) const;
   void event_callback_add( ::efl::eolian::in_traits<Elm_Event_Cb>::type func,  ::efl::eolian::in_traits<void const*>::type data) const;
   void access( ::efl::eolian::in_traits<bool>::type acs) const;
   void* event_callback_del( ::efl::eolian::in_traits<Elm_Event_Cb>::type func,  ::efl::eolian::in_traits<void const*>::type data) const;
   bool on_focus( ::efl::eolian::in_traits< ::elm::widget::Item>::type item) const;
   bool on_focus_region( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   void focus_cycle( ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
   bool focus_direction( ::efl::eolian::in_traits< ::efl::canvas::Object>::type base,  ::efl::eolian::in_traits<double>::type degree,  ::efl::eolian::out_traits< ::efl::canvas::Object>::type direction,  ::efl::eolian::out_traits< ::elm::widget::Item>::type direction_item,  ::efl::eolian::out_traits<double>::type weight) const;
   void signal_callback_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Edje_Signal_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   bool focus_next_manager_is() const;
    ::efl::canvas::Object name_find( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name,  ::efl::eolian::in_traits<int>::type recurse) const;
   bool focus_list_direction_get( ::efl::eolian::in_traits< ::efl::canvas::Object>::type base,  ::efl::eolian::in_traits<  ::efl::eina::range_list< ::eo::Base>>::type items,  ::efl::eolian::in_traits<list_data_get_func_type>::type list_data_get,  ::efl::eolian::in_traits<double>::type degree,  ::efl::eolian::out_traits< ::efl::canvas::Object>::type direction,  ::efl::eolian::out_traits< ::elm::widget::Item>::type direction_item,  ::efl::eolian::out_traits<double>::type weight) const;
   void focused_object_clear() const;
   bool focus_direction_go( ::efl::eolian::in_traits<double>::type degree) const;
   void show_region_set( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h,  ::efl::eolian::in_traits<bool>::type forceshow) const;
   void show_region_get( ::efl::eolian::out_traits<Evas_Coord*>::type x,  ::efl::eolian::out_traits<Evas_Coord*>::type y,  ::efl::eolian::out_traits<Evas_Coord*>::type w,  ::efl::eolian::out_traits<Evas_Coord*>::type h) const;
   void scroll_freeze_pop() const;
   bool focus_next_get( ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir,  ::efl::eolian::out_traits< ::efl::canvas::Object>::type next,  ::efl::eolian::out_traits< ::elm::widget::Item>::type next_item) const;
    ::efl::eina::string_view translatable_part_text_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void focus_restore() const;
   void scroll_hold_pop() const;
   bool translate() const;
   void scroll_freeze_push() const;
   void focus_custom_chain_unset() const;
   void focus_steal( ::efl::eolian::in_traits< ::elm::widget::Item>::type item) const;
   void focus_hide_handle() const;
   bool focus_next( ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir,  ::efl::eolian::out_traits< ::efl::canvas::Object>::type next,  ::efl::eolian::out_traits< ::elm::widget::Item>::type next_item) const;
   bool focus_list_next_get( ::efl::eolian::in_traits<  ::efl::eina::range_list< ::eo::Base>>::type items,  ::efl::eolian::in_traits<list_data_get_func_type>::type list_data_get,  ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir,  ::efl::eolian::out_traits< ::efl::canvas::Object>::type next,  ::efl::eolian::out_traits< ::elm::widget::Item>::type next_item) const;
   void focus_mouse_up_handle() const;
   Elm_Theme_Apply theme_apply() const;
   bool focus_direction_get( ::efl::eolian::in_traits< ::efl::canvas::Object>::type base,  ::efl::eolian::in_traits<double>::type degree,  ::efl::eolian::out_traits< ::efl::canvas::Object>::type direction,  ::efl::eolian::out_traits< ::elm::widget::Item>::type direction_item,  ::efl::eolian::out_traits<double>::type weight) const;
   void* signal_callback_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Edje_Signal_Cb>::type func) const;
   void signal_emit( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source) const;
   bool disable() const;
   bool sub_object_del( ::efl::eolian::in_traits< ::efl::canvas::Object>::type sobj) const;
   void focus_region_show() const;
   void focus_disabled_handle() const;
   void focus_custom_chain_append( ::efl::eolian::in_traits< ::efl::canvas::Object>::type child,  ::efl::eolian::in_traits< ::efl::canvas::Object>::type relative_child) const;
   void focus_reconfigure() const;
   static Eo_Class const* _eo_class()
   {
      return ELM_WIDGET_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::Widget() const;
   operator ::elm::Widget&();
   operator ::elm::Widget const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Widget,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Widget const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace elm { 
struct Widget : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl ::canvas::Group)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Accessible)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Component)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Widget( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Widget(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Widget(Widget const& other) = default;
   Widget(Widget&& other) = default;
   Widget& operator=(Widget const& other) = default;
   Widget& operator=(Widget&& other) = default;
   Widget()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Widget( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Widget(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   bool focus_get() const;
   void focus_set( ::efl::eolian::in_traits<bool>::type focus) const;
   bool drag_lock_y_get() const;
   void drag_lock_y_set( ::efl::eolian::in_traits<bool>::type lock) const;
    ::efl::eina::string_view focus_highlight_style_get() const;
   bool focus_highlight_style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
   bool tree_unfocusable_get() const;
   void tree_unfocusable_set( ::efl::eolian::in_traits<bool>::type tree_unfocusable) const;
   bool mirrored_get() const;
   void mirrored_set( ::efl::eolian::in_traits<bool>::type mirrored) const;
   bool disabled_get() const;
   void disabled_set( ::efl::eolian::in_traits<bool>::type disabled) const;
   bool highlight_ignore_get() const;
   void highlight_ignore_set( ::efl::eolian::in_traits<bool>::type ignore) const;
   bool mirrored_automatic_get() const;
   void mirrored_automatic_set( ::efl::eolian::in_traits<bool>::type automatic) const;
   bool orientation_mode_disabled_get() const;
   void orientation_mode_disabled_set( ::efl::eolian::in_traits<bool>::type disabled) const;
    ::efl::eina::string_view style_get() const;
   Elm_Theme_Apply style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
   double scale_get() const;
   void scale_set( ::efl::eolian::in_traits<double>::type scale) const;
     ::efl::eina::range_list< ::efl::canvas::Object> focus_custom_chain_get() const;
   void focus_custom_chain_set( ::efl::eolian::in_traits<  ::efl::eina::range_list< ::efl::canvas::Object>>::type objs) const;
   bool can_focus_get() const;
   void can_focus_set( ::efl::eolian::in_traits<bool>::type can_focus) const;
   bool highlight_in_theme_get() const;
   void highlight_in_theme_set( ::efl::eolian::in_traits<bool>::type highlight) const;
    ::efl::canvas::Object widget_parent_get() const;
   void widget_parent_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type parent) const;
    ::efl::eina::string_view access_info_get() const;
   void access_info_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type txt) const;
   bool drag_lock_x_get() const;
   void drag_lock_x_set( ::efl::eolian::in_traits<bool>::type lock) const;
   bool access_highlight_in_theme_get() const;
   void access_highlight_in_theme_set( ::efl::eolian::in_traits<bool>::type highlight) const;
   Elm_Focus_Region_Show_Mode focus_region_show_mode_get() const;
   void focus_region_show_mode_set( ::efl::eolian::in_traits<Elm_Focus_Region_Show_Mode>::type mode) const;
   void parent_highlight_set( ::efl::eolian::in_traits<bool>::type highlighted) const;
   Elm_Theme_Apply theme_object_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type edj,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type wname,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type welement,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type wstyle) const;
   void hover_object_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type sobj) const;
   void display_mode_set( ::efl::eolian::in_traits<Efl_Gfx_Size_Hint_Mode>::type dispmode) const;
   void on_show_region_hook_set( ::efl::eolian::in_traits<region_hook_func_type>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void domain_part_text_translatable_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type domain,  ::efl::eolian::in_traits<bool>::type translatable) const;
   void orientation_set( ::efl::eolian::in_traits<int>::type rotation) const;
   void resize_object_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type sobj,  ::efl::eolian::in_traits<bool>::type sub_obj) const;
   void domain_translatable_part_text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type domain,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type label) const;
     ::efl::eina::list< ::efl::canvas::Object> scrollable_children_get() const;
   int scroll_hold_get() const;
   int drag_child_locked_y_get() const;
   bool item_loop_enabled_get() const;
   void item_loop_enabled_set( ::efl::eolian::in_traits<bool>::type enable) const;
   bool child_can_focus_get() const;
   int scroll_freeze_get() const;
   bool focus_region_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
    ::efl::canvas::Object top_get() const;
    unsigned int focus_order_get() const;
   int drag_child_locked_x_get() const;
     ::efl::eina::list< ::efl::canvas::Object> can_focus_child_list_get() const;
    ::elm::widget::Item focused_item_get() const;
   void parents_bounce_get( ::efl::eolian::out_traits<bool>::type horiz,  ::efl::eolian::out_traits<bool>::type vert) const;
    ::efl::canvas::Object parent_widget_get() const;
   bool highlight_get() const;
    ::efl::canvas::Object focused_object_get() const;
    ::efl::canvas::Object parent2_get() const;
   void parent2_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type parent) const;
    ::efl::eina::string_view part_text_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type label) const;
   Efl_Ui_Focus_Move_Policy focus_move_policy_get() const;
   void focus_move_policy_set( ::efl::eolian::in_traits<Efl_Ui_Focus_Move_Policy>::type policy) const;
   bool focus_move_policy_automatic_get() const;
   void focus_move_policy_automatic_set( ::efl::eolian::in_traits<bool>::type automatic) const;
    ::efl::canvas::Object newest_focus_order_get( ::efl::eolian::out_traits< unsigned int>::type newest_focus_order,  ::efl::eolian::in_traits<bool>::type can_focus_only) const;
   void scroll_hold_push() const;
   void focus_next_object_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type next,  ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
    ::efl::canvas::Object focus_next_object_get( ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
   void focus_next_item_set( ::efl::eolian::in_traits< ::elm::widget::Item>::type next_item,  ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
    ::elm::widget::Item focus_next_item_get( ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
   void focus_tree_unfocusable_handle() const;
   void focus_custom_chain_prepend( ::efl::eolian::in_traits< ::efl::canvas::Object>::type child,  ::efl::eolian::in_traits< ::efl::canvas::Object>::type relative_child) const;
    ::efl::eina::string_view part_text_translate( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   void focus_highlight_geometry_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   bool activate( ::efl::eolian::in_traits<Elm_Activate>::type act) const;
   bool sub_object_add( ::efl::eolian::in_traits< ::efl::canvas::Object>::type sobj) const;
   bool focus_direction_manager_is() const;
   bool event( ::efl::eolian::in_traits< ::efl::canvas::Object>::type source,  ::efl::eolian::in_traits<Evas_Callback_Type>::type type,  ::efl::eolian::in_traits<void*>::type event_info) const;
   void event_callback_add( ::efl::eolian::in_traits<Elm_Event_Cb>::type func,  ::efl::eolian::in_traits<void const*>::type data) const;
   void access( ::efl::eolian::in_traits<bool>::type acs) const;
   void* event_callback_del( ::efl::eolian::in_traits<Elm_Event_Cb>::type func,  ::efl::eolian::in_traits<void const*>::type data) const;
   bool on_focus( ::efl::eolian::in_traits< ::elm::widget::Item>::type item) const;
   bool on_focus_region( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type w,  ::efl::eolian::out_traits<Evas_Coord>::type h) const;
   void focus_cycle( ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
   bool focus_direction( ::efl::eolian::in_traits< ::efl::canvas::Object>::type base,  ::efl::eolian::in_traits<double>::type degree,  ::efl::eolian::out_traits< ::efl::canvas::Object>::type direction,  ::efl::eolian::out_traits< ::elm::widget::Item>::type direction_item,  ::efl::eolian::out_traits<double>::type weight) const;
   void signal_callback_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Edje_Signal_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   bool focus_next_manager_is() const;
    ::efl::canvas::Object name_find( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name,  ::efl::eolian::in_traits<int>::type recurse) const;
   bool focus_list_direction_get( ::efl::eolian::in_traits< ::efl::canvas::Object>::type base,  ::efl::eolian::in_traits<  ::efl::eina::range_list< ::eo::Base>>::type items,  ::efl::eolian::in_traits<list_data_get_func_type>::type list_data_get,  ::efl::eolian::in_traits<double>::type degree,  ::efl::eolian::out_traits< ::efl::canvas::Object>::type direction,  ::efl::eolian::out_traits< ::elm::widget::Item>::type direction_item,  ::efl::eolian::out_traits<double>::type weight) const;
   void focused_object_clear() const;
   bool focus_direction_go( ::efl::eolian::in_traits<double>::type degree) const;
   void show_region_set( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h,  ::efl::eolian::in_traits<bool>::type forceshow) const;
   void show_region_get( ::efl::eolian::out_traits<Evas_Coord*>::type x,  ::efl::eolian::out_traits<Evas_Coord*>::type y,  ::efl::eolian::out_traits<Evas_Coord*>::type w,  ::efl::eolian::out_traits<Evas_Coord*>::type h) const;
   void scroll_freeze_pop() const;
   bool focus_next_get( ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir,  ::efl::eolian::out_traits< ::efl::canvas::Object>::type next,  ::efl::eolian::out_traits< ::elm::widget::Item>::type next_item) const;
    ::efl::eina::string_view translatable_part_text_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void focus_restore() const;
   void scroll_hold_pop() const;
   bool translate() const;
   void scroll_freeze_push() const;
   void focus_custom_chain_unset() const;
   void focus_steal( ::efl::eolian::in_traits< ::elm::widget::Item>::type item) const;
   void focus_hide_handle() const;
   bool focus_next( ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir,  ::efl::eolian::out_traits< ::efl::canvas::Object>::type next,  ::efl::eolian::out_traits< ::elm::widget::Item>::type next_item) const;
   bool focus_list_next_get( ::efl::eolian::in_traits<  ::efl::eina::range_list< ::eo::Base>>::type items,  ::efl::eolian::in_traits<list_data_get_func_type>::type list_data_get,  ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir,  ::efl::eolian::out_traits< ::efl::canvas::Object>::type next,  ::efl::eolian::out_traits< ::elm::widget::Item>::type next_item) const;
   void focus_mouse_up_handle() const;
   Elm_Theme_Apply theme_apply() const;
   bool focus_direction_get( ::efl::eolian::in_traits< ::efl::canvas::Object>::type base,  ::efl::eolian::in_traits<double>::type degree,  ::efl::eolian::out_traits< ::efl::canvas::Object>::type direction,  ::efl::eolian::out_traits< ::elm::widget::Item>::type direction_item,  ::efl::eolian::out_traits<double>::type weight) const;
   void* signal_callback_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Edje_Signal_Cb>::type func) const;
   void signal_emit( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source) const;
   bool disable() const;
   bool sub_object_del( ::efl::eolian::in_traits< ::efl::canvas::Object>::type sobj) const;
   void focus_region_show() const;
   void focus_disabled_handle() const;
   void focus_custom_chain_append( ::efl::eolian::in_traits< ::efl::canvas::Object>::type child,  ::efl::eolian::in_traits< ::efl::canvas::Object>::type relative_child) const;
   void focus_reconfigure() const;
   static Eo_Class const* _eo_class()
   {
      return ELM_WIDGET_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct moved_event
   {
      static Eo_Event_Description const* description()
      { return ELM_WIDGET_EVENT_MOVED; }
      typedef void parameter_type;
   } const moved_event;
   static struct focused_event
   {
      static Eo_Event_Description const* description()
      { return ELM_WIDGET_EVENT_FOCUSED; }
      typedef void parameter_type;
   } const focused_event;
   static struct unfocused_event
   {
      static Eo_Event_Description const* description()
      { return ELM_WIDGET_EVENT_UNFOCUSED; }
      typedef void parameter_type;
   } const unfocused_event;
   static struct language_changed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_WIDGET_EVENT_LANGUAGE_CHANGED; }
      typedef void parameter_type;
   } const language_changed_event;
   static struct access_changed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_WIDGET_EVENT_ACCESS_CHANGED; }
      typedef void parameter_type;
   } const access_changed_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Widget,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Widget const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Widget) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Widget>::value, "");
} 
#include "elm_widget.eo.impl.hh"
#endif
