#ifndef ELM_WIDGET_ITEM_EO_HH
#define ELM_WIDGET_ITEM_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_canvas_object.eo.h"
#include "elm_interface_atspi_accessible.eo.h"
#include "elm_interface_atspi_component.eo.h"
#include "elm_widget_item.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_canvas_object.eo.hh"
#include "elm_interface_atspi_accessible.eo.hh"
#include "elm_interface_atspi_component.eo.hh"
#include "eo_base.eo.hh"
namespace elm { namespace widget { 
struct Item;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::widget::Item> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { namespace widget { 
struct Item {
   bool tooltip_window_mode_get() const;
   bool tooltip_window_mode_set( ::efl::eolian::in_traits<bool>::type disable) const;
    ::efl::eina::string_view tooltip_style_get() const;
   void tooltip_style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
    ::efl::eina::string_view cursor_get() const;
   void cursor_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type cursor) const;
    ::efl::eina::string_view cursor_style_get() const;
   void cursor_style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
   bool cursor_engine_only_get() const;
   void cursor_engine_only_set( ::efl::eolian::in_traits<bool>::type engine_only) const;
    ::efl::canvas::Object part_content_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_content_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::canvas::Object>::type content) const;
    ::efl::eina::string_view part_text_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type label) const;
    ::efl::eina::string_view part_text_custom_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_custom_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type label) const;
   bool focus_get() const;
   void focus_set( ::efl::eolian::in_traits<bool>::type focused) const;
    ::efl::eina::string_view style_get() const;
   void style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
   bool disabled_get() const;
   void disabled_set( ::efl::eolian::in_traits<bool>::type disable) const;
     ::efl::eina::range_list< ::efl::canvas::Object> access_order_get() const;
   void access_order_set( ::efl::eolian::in_traits<  ::efl::eina::list< ::efl::canvas::Object>>::type objs) const;
    ::efl::canvas::Object widget_get() const;
   void del() const;
   void pre_notify_del() const;
   void tooltip_text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   void tooltip_translatable_text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   void tooltip_unset() const;
   void cursor_unset() const;
    ::efl::canvas::Object part_content_unset( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_custom_update() const;
   void signal_callback_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Elm_Object_Item_Signal_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void* signal_callback_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Elm_Object_Item_Signal_Cb>::type func) const;
   void signal_emit( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source) const;
   void access_info_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type txt) const;
    ::efl::canvas::Object access_object_get() const;
   void domain_translatable_part_text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type domain,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type label) const;
    ::efl::eina::string_view translatable_part_text_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void translate() const;
   void domain_part_text_translatable_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type domain,  ::efl::eolian::in_traits<bool>::type translatable) const;
    ::efl::canvas::Object track() const;
   void untrack() const;
   int track_get() const;
   void track_cancel() const;
   void del_cb_set( ::efl::eolian::in_traits<Evas_Smart_Cb>::type del_cb) const;
   void tooltip_content_cb_set( ::efl::eolian::in_traits<Elm_Tooltip_Item_Content_Cb>::type func,  ::efl::eolian::in_traits<void const*>::type data,  ::efl::eolian::in_traits< ::efl::eina::optional<Evas_Smart_Cb>>::type del_cb) const;
    ::efl::canvas::Object access_register() const;
   void access_unregister() const;
   void access_order_unset() const;
   void disable() const;
   bool del_pre() const;
    ::efl::canvas::Object focus_next_object_get( ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
   void focus_next_object_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type next,  ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
    ::elm::widget::Item focus_next_item_get( ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
   void focus_next_item_set( ::efl::eolian::in_traits< ::elm::widget::Item>::type next_item,  ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_WIDGET_ITEM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::widget::Item() const;
   operator ::elm::widget::Item&();
   operator ::elm::widget::Item const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Item,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Item const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace elm { namespace widget { 
struct Item : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Accessible)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Component)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Item( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Item(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Item(Item const& other) = default;
   Item(Item&& other) = default;
   Item& operator=(Item const& other) = default;
   Item& operator=(Item&& other) = default;
   Item()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Item( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Item(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   bool tooltip_window_mode_get() const;
   bool tooltip_window_mode_set( ::efl::eolian::in_traits<bool>::type disable) const;
    ::efl::eina::string_view tooltip_style_get() const;
   void tooltip_style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
    ::efl::eina::string_view cursor_get() const;
   void cursor_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type cursor) const;
    ::efl::eina::string_view cursor_style_get() const;
   void cursor_style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
   bool cursor_engine_only_get() const;
   void cursor_engine_only_set( ::efl::eolian::in_traits<bool>::type engine_only) const;
    ::efl::canvas::Object part_content_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_content_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::canvas::Object>::type content) const;
    ::efl::eina::string_view part_text_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type label) const;
    ::efl::eina::string_view part_text_custom_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_custom_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type label) const;
   bool focus_get() const;
   void focus_set( ::efl::eolian::in_traits<bool>::type focused) const;
    ::efl::eina::string_view style_get() const;
   void style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
   bool disabled_get() const;
   void disabled_set( ::efl::eolian::in_traits<bool>::type disable) const;
     ::efl::eina::range_list< ::efl::canvas::Object> access_order_get() const;
   void access_order_set( ::efl::eolian::in_traits<  ::efl::eina::list< ::efl::canvas::Object>>::type objs) const;
    ::efl::canvas::Object widget_get() const;
   void del() const;
   void pre_notify_del() const;
   void tooltip_text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   void tooltip_translatable_text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   void tooltip_unset() const;
   void cursor_unset() const;
    ::efl::canvas::Object part_content_unset( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void part_text_custom_update() const;
   void signal_callback_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Elm_Object_Item_Signal_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   void* signal_callback_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Elm_Object_Item_Signal_Cb>::type func) const;
   void signal_emit( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source) const;
   void access_info_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type txt) const;
    ::efl::canvas::Object access_object_get() const;
   void domain_translatable_part_text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type domain,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type label) const;
    ::efl::eina::string_view translatable_part_text_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   void translate() const;
   void domain_part_text_translatable_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type domain,  ::efl::eolian::in_traits<bool>::type translatable) const;
    ::efl::canvas::Object track() const;
   void untrack() const;
   int track_get() const;
   void track_cancel() const;
   void del_cb_set( ::efl::eolian::in_traits<Evas_Smart_Cb>::type del_cb) const;
   void tooltip_content_cb_set( ::efl::eolian::in_traits<Elm_Tooltip_Item_Content_Cb>::type func,  ::efl::eolian::in_traits<void const*>::type data,  ::efl::eolian::in_traits< ::efl::eina::optional<Evas_Smart_Cb>>::type del_cb) const;
    ::efl::canvas::Object access_register() const;
   void access_unregister() const;
   void access_order_unset() const;
   void disable() const;
   bool del_pre() const;
    ::efl::canvas::Object focus_next_object_get( ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
   void focus_next_object_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type next,  ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
    ::elm::widget::Item focus_next_item_get( ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
   void focus_next_item_set( ::efl::eolian::in_traits< ::elm::widget::Item>::type next_item,  ::efl::eolian::in_traits<Elm_Focus_Direction>::type dir) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_WIDGET_ITEM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Item,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Item const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Item) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Item>::value, "");
} } 
#include "elm_widget_item.eo.impl.hh"
#endif
