#ifndef EFL_CANVAS_TEXT_CURSOR_EO_HH
#define EFL_CANVAS_TEXT_CURSOR_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_canvas_object.eo.h"
#include "efl_canvas_text_cursor.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_canvas_object.eo.hh"
#include "eo_base.eo.hh"
namespace efl { namespace canvas { namespace text { 
struct Cursor;
} } } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::canvas::text::Cursor> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace canvas { namespace text { 
struct Cursor {
    ::efl::canvas::Object text_object_get() const;
   void text_object_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type tb) const;
   int position_get() const;
   void position_set( ::efl::eolian::in_traits<int>::type position) const;
   bool geometry_get( ::efl::eolian::in_traits<Efl_Canvas_Text_Cursor_Type>::type ctype,  ::efl::eolian::out_traits<Evas_Coord>::type cx,  ::efl::eolian::out_traits<Evas_Coord>::type cy,  ::efl::eolian::out_traits<Evas_Coord>::type cw,  ::efl::eolian::out_traits<Evas_Coord>::type ch,  ::efl::eolian::out_traits<Evas_Coord>::type cx2,  ::efl::eolian::out_traits<Evas_Coord>::type cy2,  ::efl::eolian::out_traits<Evas_Coord>::type cw2,  ::efl::eolian::out_traits<Evas_Coord>::type ch2) const;
   Eina_Unicode content_get() const;
   void copy( ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type src) const;
   int text_insert( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   void char_prev() const;
   void char_next() const;
   void char_delete() const;
   void paragraph_first() const;
   void paragraph_last() const;
   void paragraph_next() const;
   void paragraph_prev() const;
   void paragraph_char_first() const;
   void paragraph_char_last() const;
   void word_start() const;
   void word_end() const;
   void line_char_first() const;
   void line_char_last() const;
   void line_jump_by( ::efl::eolian::in_traits<int>::type by) const;
   int compare( ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type cur) const;
   bool equal( ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type cur) const;
   void coord_set( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_CANVAS_TEXT_CURSOR_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::canvas::text::Cursor() const;
   operator ::efl::canvas::text::Cursor&();
   operator ::efl::canvas::text::Cursor const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Cursor,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Cursor const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } } 
}
namespace efl { namespace canvas { namespace text { 
struct Cursor : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Cursor( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Cursor(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Cursor(Cursor const& other) = default;
   Cursor(Cursor&& other) = default;
   Cursor& operator=(Cursor const& other) = default;
   Cursor& operator=(Cursor&& other) = default;
   Cursor()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Cursor( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Cursor(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
    ::efl::canvas::Object text_object_get() const;
   void text_object_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type tb) const;
   int position_get() const;
   void position_set( ::efl::eolian::in_traits<int>::type position) const;
   bool geometry_get( ::efl::eolian::in_traits<Efl_Canvas_Text_Cursor_Type>::type ctype,  ::efl::eolian::out_traits<Evas_Coord>::type cx,  ::efl::eolian::out_traits<Evas_Coord>::type cy,  ::efl::eolian::out_traits<Evas_Coord>::type cw,  ::efl::eolian::out_traits<Evas_Coord>::type ch,  ::efl::eolian::out_traits<Evas_Coord>::type cx2,  ::efl::eolian::out_traits<Evas_Coord>::type cy2,  ::efl::eolian::out_traits<Evas_Coord>::type cw2,  ::efl::eolian::out_traits<Evas_Coord>::type ch2) const;
   Eina_Unicode content_get() const;
   void copy( ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type src) const;
   int text_insert( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   void char_prev() const;
   void char_next() const;
   void char_delete() const;
   void paragraph_first() const;
   void paragraph_last() const;
   void paragraph_next() const;
   void paragraph_prev() const;
   void paragraph_char_first() const;
   void paragraph_char_last() const;
   void word_start() const;
   void word_end() const;
   void line_char_first() const;
   void line_char_last() const;
   void line_jump_by( ::efl::eolian::in_traits<int>::type by) const;
   int compare( ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type cur) const;
   bool equal( ::efl::eolian::in_traits< ::efl::canvas::text::Cursor>::type cur) const;
   void coord_set( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_CANVAS_TEXT_CURSOR_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct changed_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_TEXT_CURSOR_EVENT_CHANGED; }
      typedef void parameter_type;
   } const changed_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Cursor,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Cursor const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Cursor) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Cursor>::value, "");
} } } 
#include "efl_canvas_text_cursor.eo.impl.hh"
#endif
