#ifndef EFL_EVENT_INPUT_EO_HH
#define EFL_EVENT_INPUT_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_event.eo.h"
#include "efl_event_input.eo.h"
#include "efl_input_device.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_event.eo.hh"
#include "efl_input_device.eo.hh"
namespace efl { namespace event { 
struct Input;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::event::Input> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace event { 
struct Input {
    ::efl::input::Device device_get() const;
   void device_set( ::efl::eolian::in_traits< ::efl::input::Device>::type dev) const;
   Efl_Event_Flags event_flags_get() const;
   void event_flags_set( ::efl::eolian::in_traits<Efl_Event_Flags>::type flags) const;
   bool processed_get() const;
   void processed_set( ::efl::eolian::in_traits<bool>::type val) const;
   bool scrolling_get() const;
   void scrolling_set( ::efl::eolian::in_traits<bool>::type val) const;
   bool fake_get() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_EVENT_INPUT_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::event::Input() const;
   operator ::efl::event::Input&();
   operator ::efl::event::Input const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Input,  ::efl::Event> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Input const ,  ::efl::Event const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace event { 
struct Input : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Event)
{
   explicit Input( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Input(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Input(Input const& other) = default;
   Input(Input&& other) = default;
   Input& operator=(Input const& other) = default;
   Input& operator=(Input&& other) = default;
   Input()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Input( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Input(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
    ::efl::input::Device device_get() const;
   void device_set( ::efl::eolian::in_traits< ::efl::input::Device>::type dev) const;
   Efl_Event_Flags event_flags_get() const;
   void event_flags_set( ::efl::eolian::in_traits<Efl_Event_Flags>::type flags) const;
   bool processed_get() const;
   void processed_set( ::efl::eolian::in_traits<bool>::type val) const;
   bool scrolling_get() const;
   void scrolling_set( ::efl::eolian::in_traits<bool>::type val) const;
   bool fake_get() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_EVENT_INPUT_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Input,  ::efl::Event> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Input const ,  ::efl::Event const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Input) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Input>::value, "");
} } 
#include "efl_event_input.eo.impl.hh"
#endif
