#ifndef EFL_EVENT_POINTER_EO_HH
#define EFL_EVENT_POINTER_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_event.eo.h"
#include "efl_event_input.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_input_device.eo.h"
#include "efl_input_state.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_event.eo.hh"
#include "efl_event_input.eo.hh"
#include "efl_input_device.eo.hh"
#include "efl_input_state.eo.hh"
#include "eo_base.eo.hh"
namespace efl { namespace event { 
struct Pointer;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::event::Pointer> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace event { 
struct Pointer {
   Efl_Pointer_Action action_get() const;
   void action_set( ::efl::eolian::in_traits<Efl_Pointer_Action>::type act) const;
   int button_get() const;
   void button_set( ::efl::eolian::in_traits<int>::type but) const;
   bool button_pressed_get( ::efl::eolian::in_traits<int>::type button) const;
   void button_pressed_set( ::efl::eolian::in_traits<int>::type button,  ::efl::eolian::in_traits<bool>::type pressed) const;
   void position_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   void position_set( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
   void position_precise_get( ::efl::eolian::out_traits<double>::type x,  ::efl::eolian::out_traits<double>::type y) const;
   void position_precise_set( ::efl::eolian::in_traits<double>::type x,  ::efl::eolian::in_traits<double>::type y) const;
   void previous_position_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   void previous_position_set( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
   void previous_position_precise_get( ::efl::eolian::out_traits<double>::type x,  ::efl::eolian::out_traits<double>::type y) const;
   void previous_position_precise_set( ::efl::eolian::in_traits<double>::type x,  ::efl::eolian::in_traits<double>::type y) const;
   int finger_get() const;
   void finger_set( ::efl::eolian::in_traits<int>::type id) const;
   void touch_get( ::efl::eolian::out_traits<double>::type radius,  ::efl::eolian::out_traits<double>::type rad_x,  ::efl::eolian::out_traits<double>::type rad_y,  ::efl::eolian::out_traits<double>::type pressure,  ::efl::eolian::out_traits<double>::type angle) const;
   void touch_set( ::efl::eolian::in_traits<double>::type radius,  ::efl::eolian::in_traits<double>::type rad_x,  ::efl::eolian::in_traits<double>::type rad_y,  ::efl::eolian::in_traits<double>::type pressure,  ::efl::eolian::in_traits<double>::type angle) const;
    ::eo::Base source_get() const;
   void source_set( ::efl::eolian::in_traits< ::eo::Base>::type src) const;
   Efl_Pointer_Flags button_flags_get() const;
   void button_flags_set( ::efl::eolian::in_traits<Efl_Pointer_Flags>::type flags) const;
   bool double_click_get() const;
   void double_click_set( ::efl::eolian::in_traits<bool>::type val) const;
   bool triple_click_get() const;
   void triple_click_set( ::efl::eolian::in_traits<bool>::type val) const;
   Efl_Orient wheel_direction_get() const;
   void wheel_direction_set( ::efl::eolian::in_traits<Efl_Orient>::type dir) const;
   int wheel_distance_get() const;
   void wheel_distance_set( ::efl::eolian::in_traits<int>::type dist) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_EVENT_POINTER_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::event::Pointer() const;
   operator ::efl::event::Pointer&();
   operator ::efl::event::Pointer const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Pointer,  ::efl::Event,  ::efl::event::Input,  ::efl::input::State,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Pointer const ,  ::efl::Event const ,  ::efl::event::Input const ,  ::efl::input::State const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace event { 
struct Pointer : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Event)
   , EO_CXX_INHERIT( ::efl ::event::Input)
   , EO_CXX_INHERIT( ::efl ::input::State)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Pointer( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Pointer(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Pointer(Pointer const& other) = default;
   Pointer(Pointer&& other) = default;
   Pointer& operator=(Pointer const& other) = default;
   Pointer& operator=(Pointer&& other) = default;
   Pointer()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Pointer( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Pointer(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   Efl_Pointer_Action action_get() const;
   void action_set( ::efl::eolian::in_traits<Efl_Pointer_Action>::type act) const;
   int button_get() const;
   void button_set( ::efl::eolian::in_traits<int>::type but) const;
   bool button_pressed_get( ::efl::eolian::in_traits<int>::type button) const;
   void button_pressed_set( ::efl::eolian::in_traits<int>::type button,  ::efl::eolian::in_traits<bool>::type pressed) const;
   void position_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   void position_set( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
   void position_precise_get( ::efl::eolian::out_traits<double>::type x,  ::efl::eolian::out_traits<double>::type y) const;
   void position_precise_set( ::efl::eolian::in_traits<double>::type x,  ::efl::eolian::in_traits<double>::type y) const;
   void previous_position_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   void previous_position_set( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
   void previous_position_precise_get( ::efl::eolian::out_traits<double>::type x,  ::efl::eolian::out_traits<double>::type y) const;
   void previous_position_precise_set( ::efl::eolian::in_traits<double>::type x,  ::efl::eolian::in_traits<double>::type y) const;
   int finger_get() const;
   void finger_set( ::efl::eolian::in_traits<int>::type id) const;
   void touch_get( ::efl::eolian::out_traits<double>::type radius,  ::efl::eolian::out_traits<double>::type rad_x,  ::efl::eolian::out_traits<double>::type rad_y,  ::efl::eolian::out_traits<double>::type pressure,  ::efl::eolian::out_traits<double>::type angle) const;
   void touch_set( ::efl::eolian::in_traits<double>::type radius,  ::efl::eolian::in_traits<double>::type rad_x,  ::efl::eolian::in_traits<double>::type rad_y,  ::efl::eolian::in_traits<double>::type pressure,  ::efl::eolian::in_traits<double>::type angle) const;
    ::eo::Base source_get() const;
   void source_set( ::efl::eolian::in_traits< ::eo::Base>::type src) const;
   Efl_Pointer_Flags button_flags_get() const;
   void button_flags_set( ::efl::eolian::in_traits<Efl_Pointer_Flags>::type flags) const;
   bool double_click_get() const;
   void double_click_set( ::efl::eolian::in_traits<bool>::type val) const;
   bool triple_click_get() const;
   void triple_click_set( ::efl::eolian::in_traits<bool>::type val) const;
   Efl_Orient wheel_direction_get() const;
   void wheel_direction_set( ::efl::eolian::in_traits<Efl_Orient>::type dir) const;
   int wheel_distance_get() const;
   void wheel_distance_set( ::efl::eolian::in_traits<int>::type dist) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_EVENT_POINTER_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Pointer,  ::efl::Event,  ::efl::event::Input,  ::efl::input::State,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Pointer const ,  ::efl::Event const ,  ::efl::event::Input const ,  ::efl::input::State const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Pointer) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Pointer>::value, "");
} } 
#include "efl_event_pointer.eo.impl.hh"
#endif
