#ifndef EVAS_CANVAS_EO_HH
#define EVAS_CANVAS_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_gfx.eo.h"
#include "efl_input_device.eo.h"
#include "efl_input_interface.eo.h"
#include "eo_base.eo.h"
#include "evas_canvas.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_input_device.eo.hh"
#include "efl_input_interface.eo.hh"
#include "eo_base.eo.hh"
namespace evas { 
struct Canvas;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::Canvas> : ::std::true_type {}; } }

namespace eo_cxx {
namespace evas { 
struct Canvas {
   int image_cache_get() const;
   void image_cache_set( ::efl::eolian::in_traits<int>::type size) const;
   Efl_Event_Flags event_default_flags_get() const;
   void event_default_flags_set( ::efl::eolian::in_traits<Efl_Event_Flags>::type flags) const;
   int font_cache_get() const;
   void font_cache_set( ::efl::eolian::in_traits<int>::type size) const;
   void* data_attach_get() const;
   void data_attach_set( ::efl::eolian::in_traits<void*>::type data) const;
   Evas_Font_Hinting_Flags font_hinting_get() const;
   void font_hinting_set( ::efl::eolian::in_traits<Evas_Font_Hinting_Flags>::type hinting) const;
    ::efl::canvas::Object focus_get() const;
    ::efl::canvas::Object object_top_get() const;
   void pointer_canvas_xy_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y) const;
   int event_down_count_get() const;
   int smart_objects_calculate_count_get() const;
   bool focus_state_get() const;
   bool changed_get() const;
   void pointer_output_xy_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   bool pointer_inside_get() const;
   bool image_max_size_get( ::efl::eolian::out_traits<int>::type maxw,  ::efl::eolian::out_traits<int>::type maxh) const;
    ::efl::canvas::Object object_bottom_get() const;
    unsigned int pointer_button_down_mask_get() const;
     ::efl::eina::range_list< ::efl::canvas::Object> tree_objects_at_xy_get( ::efl::eolian::in_traits< ::efl::canvas::Object>::type stop,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
   void key_lock_on( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   Evas_Modifier_Mask key_modifier_mask_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   void key_modifier_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   void key_modifier_off( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
     ::efl::eina::range_list< ::efl::canvas::Object> objects_at_xy_get( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   bool render_async() const;
   bool render2() const;
   void focus_out() const;
   void norender() const;
    unsigned int touch_point_list_count() const;
   void nochange_pop() const;
   void key_lock_off( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   void nochange_push() const;
   void font_cache_flush() const;
   bool font_hinting_can_hint( ::efl::eolian::in_traits<Evas_Font_Hinting_Flags>::type hinting) const;
    ::efl::canvas::Object object_top_at_xy_get( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   void key_modifier_on( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
     ::efl::eina::range_list< ::efl::eina::string_view> font_available_list() const;
     ::efl::eina::range_list< ::efl::canvas::Object> objects_in_rectangle_get( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
    ::efl::canvas::Object object_name_find( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   void font_path_append( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   int touch_point_list_nth_id_get( ::efl::eolian::in_traits< unsigned int>::type n) const;
   void font_path_clear() const;
   void smart_objects_calculate() const;
   void touch_point_list_nth_xy_get( ::efl::eolian::in_traits< unsigned int>::type n,  ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y) const;
   void key_lock_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   void damage_rectangle_add( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   void sync() const;
     ::efl::eina::range_list< ::efl::eina::string_view> font_path_list() const;
   void image_cache_reload() const;
   int coord_world_x_to_screen( ::efl::eolian::in_traits<Evas_Coord>::type x) const;
   void image_cache_flush() const;
   Evas_Coord coord_screen_y_to_world( ::efl::eolian::in_traits<int>::type y) const;
   void key_modifier_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   Evas_Touch_Point_State touch_point_list_nth_state_get( ::efl::eolian::in_traits< unsigned int>::type n) const;
   void focus_in() const;
   void obscured_rectangle_add( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   void render_dump() const;
    ::efl::canvas::Object object_top_in_rectangle_get( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   void render() const;
   void font_path_prepend( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   void obscured_clear() const;
   Evas_Coord coord_screen_x_to_world( ::efl::eolian::in_traits<int>::type x) const;
   void key_lock_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   void render_idle_flush() const;
   int coord_world_y_to_screen( ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_CANVAS_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::evas::Canvas() const;
   operator ::evas::Canvas&();
   operator ::evas::Canvas const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Canvas,  ::efl::Animator,  ::efl::Canvas,  ::efl::input::Interface,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Canvas const ,  ::efl::Animator const ,  ::efl::Canvas const ,  ::efl::input::Interface const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace evas { 
struct Canvas : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Canvas)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Canvas( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Canvas(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Canvas(Canvas const& other) = default;
   Canvas(Canvas&& other) = default;
   Canvas& operator=(Canvas const& other) = default;
   Canvas& operator=(Canvas&& other) = default;
   Canvas()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Canvas( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Canvas(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   int image_cache_get() const;
   void image_cache_set( ::efl::eolian::in_traits<int>::type size) const;
   Efl_Event_Flags event_default_flags_get() const;
   void event_default_flags_set( ::efl::eolian::in_traits<Efl_Event_Flags>::type flags) const;
   int font_cache_get() const;
   void font_cache_set( ::efl::eolian::in_traits<int>::type size) const;
   void* data_attach_get() const;
   void data_attach_set( ::efl::eolian::in_traits<void*>::type data) const;
   Evas_Font_Hinting_Flags font_hinting_get() const;
   void font_hinting_set( ::efl::eolian::in_traits<Evas_Font_Hinting_Flags>::type hinting) const;
    ::efl::canvas::Object focus_get() const;
    ::efl::canvas::Object object_top_get() const;
   void pointer_canvas_xy_get( ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y) const;
   int event_down_count_get() const;
   int smart_objects_calculate_count_get() const;
   bool focus_state_get() const;
   bool changed_get() const;
   void pointer_output_xy_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   bool pointer_inside_get() const;
   bool image_max_size_get( ::efl::eolian::out_traits<int>::type maxw,  ::efl::eolian::out_traits<int>::type maxh) const;
    ::efl::canvas::Object object_bottom_get() const;
    unsigned int pointer_button_down_mask_get() const;
     ::efl::eina::range_list< ::efl::canvas::Object> tree_objects_at_xy_get( ::efl::eolian::in_traits< ::efl::canvas::Object>::type stop,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
   void key_lock_on( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   Evas_Modifier_Mask key_modifier_mask_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   void key_modifier_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   void key_modifier_off( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
     ::efl::eina::range_list< ::efl::canvas::Object> objects_at_xy_get( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   bool render_async() const;
   bool render2() const;
   void focus_out() const;
   void norender() const;
    unsigned int touch_point_list_count() const;
   void nochange_pop() const;
   void key_lock_off( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   void nochange_push() const;
   void font_cache_flush() const;
   bool font_hinting_can_hint( ::efl::eolian::in_traits<Evas_Font_Hinting_Flags>::type hinting) const;
    ::efl::canvas::Object object_top_at_xy_get( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   void key_modifier_on( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
     ::efl::eina::range_list< ::efl::eina::string_view> font_available_list() const;
     ::efl::eina::range_list< ::efl::canvas::Object> objects_in_rectangle_get( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
    ::efl::canvas::Object object_name_find( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   void font_path_append( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   int touch_point_list_nth_id_get( ::efl::eolian::in_traits< unsigned int>::type n) const;
   void font_path_clear() const;
   void smart_objects_calculate() const;
   void touch_point_list_nth_xy_get( ::efl::eolian::in_traits< unsigned int>::type n,  ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y) const;
   void key_lock_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   void damage_rectangle_add( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   void sync() const;
     ::efl::eina::range_list< ::efl::eina::string_view> font_path_list() const;
   void image_cache_reload() const;
   int coord_world_x_to_screen( ::efl::eolian::in_traits<Evas_Coord>::type x) const;
   void image_cache_flush() const;
   Evas_Coord coord_screen_y_to_world( ::efl::eolian::in_traits<int>::type y) const;
   void key_modifier_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   Evas_Touch_Point_State touch_point_list_nth_state_get( ::efl::eolian::in_traits< unsigned int>::type n) const;
   void focus_in() const;
   void obscured_rectangle_add( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   void render_dump() const;
    ::efl::canvas::Object object_top_in_rectangle_get( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   void render() const;
   void font_path_prepend( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   void obscured_clear() const;
   Evas_Coord coord_screen_x_to_world( ::efl::eolian::in_traits<int>::type x) const;
   void key_lock_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   void render_idle_flush() const;
   int coord_world_y_to_screen( ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_CANVAS_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
#ifdef EVAS_CANVAS_BETA
   static struct render_flush_pre_event
   {
      static Eo_Event_Description const* description()
      { return EVAS_CANVAS_EVENT_RENDER_FLUSH_PRE; }
      typedef void parameter_type;
   } const render_flush_pre_event;
#endif
#ifdef EVAS_CANVAS_BETA
   static struct render_flush_post_event
   {
      static Eo_Event_Description const* description()
      { return EVAS_CANVAS_EVENT_RENDER_FLUSH_POST; }
      typedef void parameter_type;
   } const render_flush_post_event;
#endif
#ifdef EVAS_CANVAS_BETA
   static struct axis_update_event
   {
      static Eo_Event_Description const* description()
      { return EVAS_CANVAS_EVENT_AXIS_UPDATE; }
      typedef void parameter_type;
   } const axis_update_event;
#endif
#ifdef EVAS_CANVAS_BETA
   static struct viewport_resize_event
   {
      static Eo_Event_Description const* description()
      { return EVAS_CANVAS_EVENT_VIEWPORT_RESIZE; }
      typedef void parameter_type;
   } const viewport_resize_event;
#endif
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Canvas,  ::efl::Animator,  ::efl::Canvas,  ::efl::input::Interface,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Canvas const ,  ::efl::Animator const ,  ::efl::Canvas const ,  ::efl::input::Interface const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Canvas) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Canvas>::value, "");
} 
#include "evas_canvas.eo.impl.hh"
#endif
