#ifndef EVAS_CANVAS3D_LIGHT_EO_HH
#define EVAS_CANVAS3D_LIGHT_EO_HH
#include <Eo.h>

extern "C" {
#include "eo_base.eo.h"
#include "evas_canvas3d_light.eo.h"
#include "evas_canvas3d_object.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "eo_base.eo.hh"
#include "evas_canvas3d_object.eo.hh"
namespace evas { namespace canvas3d { 
struct Light;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Light> : ::std::true_type {}; } }

namespace eo_cxx {
namespace evas { namespace canvas3d { 
struct Light {
   bool directional_get() const;
   void directional_set( ::efl::eolian::in_traits<bool>::type directional) const;
   Evas_Real spot_exponent_get() const;
   void spot_exponent_set( ::efl::eolian::in_traits<Evas_Real>::type exponent) const;
   Evas_Real spot_cutoff_get() const;
   void spot_cutoff_set( ::efl::eolian::in_traits<Evas_Real>::type cutoff) const;
   bool attenuation_enable_get() const;
   void attenuation_enable_set( ::efl::eolian::in_traits<bool>::type enable) const;
   void ambient_set( ::efl::eolian::in_traits<Evas_Real>::type r,  ::efl::eolian::in_traits<Evas_Real>::type g,  ::efl::eolian::in_traits<Evas_Real>::type b,  ::efl::eolian::in_traits<Evas_Real>::type a) const;
   void ambient_get( ::efl::eolian::out_traits<Evas_Real>::type r,  ::efl::eolian::out_traits<Evas_Real>::type g,  ::efl::eolian::out_traits<Evas_Real>::type b,  ::efl::eolian::out_traits<Evas_Real>::type a) const;
   void diffuse_set( ::efl::eolian::in_traits<Evas_Real>::type r,  ::efl::eolian::in_traits<Evas_Real>::type g,  ::efl::eolian::in_traits<Evas_Real>::type b,  ::efl::eolian::in_traits<Evas_Real>::type a) const;
   void diffuse_get( ::efl::eolian::out_traits<Evas_Real>::type r,  ::efl::eolian::out_traits<Evas_Real>::type g,  ::efl::eolian::out_traits<Evas_Real>::type b,  ::efl::eolian::out_traits<Evas_Real>::type a) const;
   void specular_set( ::efl::eolian::in_traits<Evas_Real>::type r,  ::efl::eolian::in_traits<Evas_Real>::type g,  ::efl::eolian::in_traits<Evas_Real>::type b,  ::efl::eolian::in_traits<Evas_Real>::type a) const;
   void specular_get( ::efl::eolian::out_traits<Evas_Real>::type r,  ::efl::eolian::out_traits<Evas_Real>::type g,  ::efl::eolian::out_traits<Evas_Real>::type b,  ::efl::eolian::out_traits<Evas_Real>::type a) const;
   void attenuation_set( ::efl::eolian::in_traits<Evas_Real>::type constant,  ::efl::eolian::in_traits<Evas_Real>::type linear,  ::efl::eolian::in_traits<Evas_Real>::type quadratic) const;
   void attenuation_get( ::efl::eolian::out_traits<Evas_Real>::type constant,  ::efl::eolian::out_traits<Evas_Real>::type linear,  ::efl::eolian::out_traits<Evas_Real>::type quadratic) const;
   void projection_matrix_get( ::efl::eolian::out_traits<Evas_Real>::type matrix) const;
   void projection_perspective_set( ::efl::eolian::in_traits<Evas_Real>::type fovy,  ::efl::eolian::in_traits<Evas_Real>::type aspect,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   void projection_frustum_set( ::efl::eolian::in_traits<Evas_Real>::type left,  ::efl::eolian::in_traits<Evas_Real>::type right,  ::efl::eolian::in_traits<Evas_Real>::type bottom,  ::efl::eolian::in_traits<Evas_Real>::type top,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   void projection_ortho_set( ::efl::eolian::in_traits<Evas_Real>::type left,  ::efl::eolian::in_traits<Evas_Real>::type right,  ::efl::eolian::in_traits<Evas_Real>::type bottom,  ::efl::eolian::in_traits<Evas_Real>::type top,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_LIGHT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::evas::canvas3d::Light() const;
   operator ::evas::canvas3d::Light&();
   operator ::evas::canvas3d::Light const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Light,  ::eo::Base,  ::evas::canvas3d::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Light const ,  ::eo::Base const ,  ::evas::canvas3d::Object const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace evas { namespace canvas3d { 
struct Light : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::evas ::canvas3d::Object)
{
   explicit Light( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Light(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Light(Light const& other) = default;
   Light(Light&& other) = default;
   Light& operator=(Light const& other) = default;
   Light& operator=(Light&& other) = default;
   Light()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Light( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Light(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   bool directional_get() const;
   void directional_set( ::efl::eolian::in_traits<bool>::type directional) const;
   Evas_Real spot_exponent_get() const;
   void spot_exponent_set( ::efl::eolian::in_traits<Evas_Real>::type exponent) const;
   Evas_Real spot_cutoff_get() const;
   void spot_cutoff_set( ::efl::eolian::in_traits<Evas_Real>::type cutoff) const;
   bool attenuation_enable_get() const;
   void attenuation_enable_set( ::efl::eolian::in_traits<bool>::type enable) const;
   void ambient_set( ::efl::eolian::in_traits<Evas_Real>::type r,  ::efl::eolian::in_traits<Evas_Real>::type g,  ::efl::eolian::in_traits<Evas_Real>::type b,  ::efl::eolian::in_traits<Evas_Real>::type a) const;
   void ambient_get( ::efl::eolian::out_traits<Evas_Real>::type r,  ::efl::eolian::out_traits<Evas_Real>::type g,  ::efl::eolian::out_traits<Evas_Real>::type b,  ::efl::eolian::out_traits<Evas_Real>::type a) const;
   void diffuse_set( ::efl::eolian::in_traits<Evas_Real>::type r,  ::efl::eolian::in_traits<Evas_Real>::type g,  ::efl::eolian::in_traits<Evas_Real>::type b,  ::efl::eolian::in_traits<Evas_Real>::type a) const;
   void diffuse_get( ::efl::eolian::out_traits<Evas_Real>::type r,  ::efl::eolian::out_traits<Evas_Real>::type g,  ::efl::eolian::out_traits<Evas_Real>::type b,  ::efl::eolian::out_traits<Evas_Real>::type a) const;
   void specular_set( ::efl::eolian::in_traits<Evas_Real>::type r,  ::efl::eolian::in_traits<Evas_Real>::type g,  ::efl::eolian::in_traits<Evas_Real>::type b,  ::efl::eolian::in_traits<Evas_Real>::type a) const;
   void specular_get( ::efl::eolian::out_traits<Evas_Real>::type r,  ::efl::eolian::out_traits<Evas_Real>::type g,  ::efl::eolian::out_traits<Evas_Real>::type b,  ::efl::eolian::out_traits<Evas_Real>::type a) const;
   void attenuation_set( ::efl::eolian::in_traits<Evas_Real>::type constant,  ::efl::eolian::in_traits<Evas_Real>::type linear,  ::efl::eolian::in_traits<Evas_Real>::type quadratic) const;
   void attenuation_get( ::efl::eolian::out_traits<Evas_Real>::type constant,  ::efl::eolian::out_traits<Evas_Real>::type linear,  ::efl::eolian::out_traits<Evas_Real>::type quadratic) const;
   void projection_matrix_get( ::efl::eolian::out_traits<Evas_Real>::type matrix) const;
   void projection_perspective_set( ::efl::eolian::in_traits<Evas_Real>::type fovy,  ::efl::eolian::in_traits<Evas_Real>::type aspect,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   void projection_frustum_set( ::efl::eolian::in_traits<Evas_Real>::type left,  ::efl::eolian::in_traits<Evas_Real>::type right,  ::efl::eolian::in_traits<Evas_Real>::type bottom,  ::efl::eolian::in_traits<Evas_Real>::type top,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   void projection_ortho_set( ::efl::eolian::in_traits<Evas_Real>::type left,  ::efl::eolian::in_traits<Evas_Real>::type right,  ::efl::eolian::in_traits<Evas_Real>::type bottom,  ::efl::eolian::in_traits<Evas_Real>::type top,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_LIGHT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Light,  ::eo::Base,  ::evas::canvas3d::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Light const ,  ::eo::Base const ,  ::evas::canvas3d::Object const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Light) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Light>::value, "");
} } 
#include "evas_canvas3d_light.eo.impl.hh"
#endif
