#ifndef EVAS_CANVAS3D_SCENE_EO_HH
#define EVAS_CANVAS3D_SCENE_EO_HH
#include <Eo.h>

extern "C" {
#include "eo_base.eo.h"
#include "evas_canvas3d_mesh.eo.h"
#include "evas_canvas3d_node.eo.h"
#include "evas_canvas3d_object.eo.h"
#include "evas_canvas3d_scene.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "eo_base.eo.hh"
#include "evas_canvas3d_mesh.eo.hh"
#include "evas_canvas3d_node.eo.hh"
#include "evas_canvas3d_object.eo.hh"
namespace evas { namespace canvas3d { 
struct Scene;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Scene> : ::std::true_type {}; } }

namespace eo_cxx {
namespace evas { namespace canvas3d { 
struct Scene {
    ::evas::canvas3d::Node root_node_get() const;
   void root_node_set( ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type node) const;
    ::evas::canvas3d::Node camera_node_get() const;
   void camera_node_set( ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type node) const;
   void shadows_depth_get( ::efl::eolian::out_traits<Evas_Real>::type depth_offset,  ::efl::eolian::out_traits<Evas_Real>::type depth_constant) const;
   void shadows_depth_set( ::efl::eolian::in_traits<Evas_Real>::type depth_offset,  ::efl::eolian::in_traits<Evas_Real>::type depth_constant) const;
   void size_set( ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   void size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   void background_color_set( ::efl::eolian::in_traits<Evas_Real>::type r,  ::efl::eolian::in_traits<Evas_Real>::type g,  ::efl::eolian::in_traits<Evas_Real>::type b,  ::efl::eolian::in_traits<Evas_Real>::type a) const;
   void background_color_get( ::efl::eolian::out_traits<Evas_Real>::type r,  ::efl::eolian::out_traits<Evas_Real>::type g,  ::efl::eolian::out_traits<Evas_Real>::type b,  ::efl::eolian::out_traits<Evas_Real>::type a) const;
   bool pick( ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y,  ::efl::eolian::out_traits< ::evas::canvas3d::Node>::type node,  ::efl::eolian::out_traits< ::evas::canvas3d::Mesh>::type mesh,  ::efl::eolian::out_traits<Evas_Real>::type s,  ::efl::eolian::out_traits<Evas_Real>::type t) const;
    ::evas::canvas3d::Node exist( ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y,  ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type node) const;
     ::efl::eina::range_list< ::evas::canvas3d::Node> pick_member_list_get( ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y) const;
   void shadows_enable_set( ::efl::eolian::in_traits<bool>::type shadows_enabled) const;
   bool shadows_enable_get() const;
   bool color_pick_enable_get() const;
   bool color_pick_enable_set( ::efl::eolian::in_traits<bool>::type color_pick) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_SCENE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::evas::canvas3d::Scene() const;
   operator ::evas::canvas3d::Scene&();
   operator ::evas::canvas3d::Scene const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Scene,  ::eo::Base,  ::evas::canvas3d::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Scene const ,  ::eo::Base const ,  ::evas::canvas3d::Object const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace evas { namespace canvas3d { 
struct Scene : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::evas ::canvas3d::Object)
{
   explicit Scene( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Scene(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Scene(Scene const& other) = default;
   Scene(Scene&& other) = default;
   Scene& operator=(Scene const& other) = default;
   Scene& operator=(Scene&& other) = default;
   Scene()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Scene( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Scene(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
    ::evas::canvas3d::Node root_node_get() const;
   void root_node_set( ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type node) const;
    ::evas::canvas3d::Node camera_node_get() const;
   void camera_node_set( ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type node) const;
   void shadows_depth_get( ::efl::eolian::out_traits<Evas_Real>::type depth_offset,  ::efl::eolian::out_traits<Evas_Real>::type depth_constant) const;
   void shadows_depth_set( ::efl::eolian::in_traits<Evas_Real>::type depth_offset,  ::efl::eolian::in_traits<Evas_Real>::type depth_constant) const;
   void size_set( ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   void size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   void background_color_set( ::efl::eolian::in_traits<Evas_Real>::type r,  ::efl::eolian::in_traits<Evas_Real>::type g,  ::efl::eolian::in_traits<Evas_Real>::type b,  ::efl::eolian::in_traits<Evas_Real>::type a) const;
   void background_color_get( ::efl::eolian::out_traits<Evas_Real>::type r,  ::efl::eolian::out_traits<Evas_Real>::type g,  ::efl::eolian::out_traits<Evas_Real>::type b,  ::efl::eolian::out_traits<Evas_Real>::type a) const;
   bool pick( ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y,  ::efl::eolian::out_traits< ::evas::canvas3d::Node>::type node,  ::efl::eolian::out_traits< ::evas::canvas3d::Mesh>::type mesh,  ::efl::eolian::out_traits<Evas_Real>::type s,  ::efl::eolian::out_traits<Evas_Real>::type t) const;
    ::evas::canvas3d::Node exist( ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y,  ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type node) const;
     ::efl::eina::range_list< ::evas::canvas3d::Node> pick_member_list_get( ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y) const;
   void shadows_enable_set( ::efl::eolian::in_traits<bool>::type shadows_enabled) const;
   bool shadows_enable_get() const;
   bool color_pick_enable_get() const;
   bool color_pick_enable_set( ::efl::eolian::in_traits<bool>::type color_pick) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_SCENE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Scene,  ::eo::Base,  ::evas::canvas3d::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Scene const ,  ::eo::Base const ,  ::evas::canvas3d::Object const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Scene) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Scene>::value, "");
} } 
#include "evas_canvas3d_scene.eo.impl.hh"
#endif
