#ifndef EVAS_CANVAS3D_TEXTURE_EO_HH
#define EVAS_CANVAS3D_TEXTURE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_canvas_object.eo.h"
#include "eo_base.eo.h"
#include "evas_canvas3d_object.eo.h"
#include "evas_canvas3d_texture.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_canvas_object.eo.hh"
#include "eo_base.eo.hh"
#include "evas_canvas3d_object.eo.hh"
namespace evas { namespace canvas3d { 
struct Texture;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Texture> : ::std::true_type {}; } }

namespace eo_cxx {
namespace evas { namespace canvas3d { 
struct Texture {
   bool source_visible_get() const;
   void source_visible_set( ::efl::eolian::in_traits<bool>::type visible) const;
   bool atlas_enable_get() const;
   void atlas_enable_set( ::efl::eolian::in_traits<bool>::type use_atlas) const;
   void data_set( ::efl::eolian::in_traits<Evas_Colorspace>::type color_format,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h,  ::efl::eolian::in_traits<void const*>::type data) const;
   void file_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type file,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   void source_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type source) const;
   Evas_Colorspace color_format_get() const;
   void size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   void wrap_set( ::efl::eolian::in_traits<Evas_Canvas3D_Wrap_Mode>::type s,  ::efl::eolian::in_traits<Evas_Canvas3D_Wrap_Mode>::type t) const;
   void wrap_get( ::efl::eolian::out_traits<Evas_Canvas3D_Wrap_Mode>::type s,  ::efl::eolian::out_traits<Evas_Canvas3D_Wrap_Mode>::type t) const;
   void filter_set( ::efl::eolian::in_traits<Evas_Canvas3D_Texture_Filter>::type min,  ::efl::eolian::in_traits<Evas_Canvas3D_Texture_Filter>::type mag) const;
   void filter_get( ::efl::eolian::out_traits<Evas_Canvas3D_Texture_Filter>::type min,  ::efl::eolian::out_traits<Evas_Canvas3D_Texture_Filter>::type mag) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_TEXTURE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::evas::canvas3d::Texture() const;
   operator ::evas::canvas3d::Texture&();
   operator ::evas::canvas3d::Texture const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Texture,  ::eo::Base,  ::evas::canvas3d::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Texture const ,  ::eo::Base const ,  ::evas::canvas3d::Object const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace evas { namespace canvas3d { 
struct Texture : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::evas ::canvas3d::Object)
{
   explicit Texture( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Texture(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Texture(Texture const& other) = default;
   Texture(Texture&& other) = default;
   Texture& operator=(Texture const& other) = default;
   Texture& operator=(Texture&& other) = default;
   Texture()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Texture( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Texture(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   bool source_visible_get() const;
   void source_visible_set( ::efl::eolian::in_traits<bool>::type visible) const;
   bool atlas_enable_get() const;
   void atlas_enable_set( ::efl::eolian::in_traits<bool>::type use_atlas) const;
   void data_set( ::efl::eolian::in_traits<Evas_Colorspace>::type color_format,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h,  ::efl::eolian::in_traits<void const*>::type data) const;
   void file_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type file,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   void source_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type source) const;
   Evas_Colorspace color_format_get() const;
   void size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   void wrap_set( ::efl::eolian::in_traits<Evas_Canvas3D_Wrap_Mode>::type s,  ::efl::eolian::in_traits<Evas_Canvas3D_Wrap_Mode>::type t) const;
   void wrap_get( ::efl::eolian::out_traits<Evas_Canvas3D_Wrap_Mode>::type s,  ::efl::eolian::out_traits<Evas_Canvas3D_Wrap_Mode>::type t) const;
   void filter_set( ::efl::eolian::in_traits<Evas_Canvas3D_Texture_Filter>::type min,  ::efl::eolian::in_traits<Evas_Canvas3D_Texture_Filter>::type mag) const;
   void filter_get( ::efl::eolian::out_traits<Evas_Canvas3D_Texture_Filter>::type min,  ::efl::eolian::out_traits<Evas_Canvas3D_Texture_Filter>::type mag) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_TEXTURE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Texture,  ::eo::Base,  ::evas::canvas3d::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Texture const ,  ::eo::Base const ,  ::evas::canvas3d::Object const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Texture) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Texture>::value, "");
} } 
#include "evas_canvas3d_texture.eo.impl.hh"
#endif
