#ifndef EVAS_TEXT_EO_HH
#define EVAS_TEXT_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas_filter_internal.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_filter.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_interface.eo.h"
#include "efl_text.eo.h"
#include "efl_text_properties.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
#include "evas_text.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_filter_internal.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_filter.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_interface.eo.hh"
#include "efl_text.eo.hh"
#include "efl_text_properties.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace evas { 
struct Text;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::Text> : ::std::true_type {}; } }

namespace eo_cxx {
namespace evas { 
struct Text {
   void shadow_color_get( ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   void shadow_color_set( ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   double ellipsis_get() const;
   void ellipsis_set( ::efl::eolian::in_traits<double>::type ellipsis) const;
    ::efl::eina::string_view bidi_delimiters_get() const;
   void bidi_delimiters_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type delim) const;
   void outline_color_get( ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   void outline_color_set( ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   void glow2_color_get( ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   void glow2_color_set( ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   Evas_Text_Style_Type style_get() const;
   void style_set( ::efl::eolian::in_traits<Evas_Text_Style_Type>::type style) const;
   void glow_color_get( ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   void glow_color_set( ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   Evas_Coord max_descent_get() const;
   void style_pad_get( ::efl::eolian::out_traits<int>::type l,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type t,  ::efl::eolian::out_traits<int>::type b) const;
   Efl_Text_Bidirectional_Type direction_get() const;
   Evas_Coord ascent_get() const;
   Evas_Coord horiz_advance_get() const;
   Evas_Coord inset_get() const;
   Evas_Coord max_ascent_get() const;
   Evas_Coord vert_advance_get() const;
   Evas_Coord descent_get() const;
   int last_up_to_pos( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   int char_coords_get( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type cx,  ::efl::eolian::out_traits<Evas_Coord>::type cy,  ::efl::eolian::out_traits<Evas_Coord>::type cw,  ::efl::eolian::out_traits<Evas_Coord>::type ch) const;
   bool char_pos_get( ::efl::eolian::in_traits<int>::type pos,  ::efl::eolian::out_traits<Evas_Coord>::type cx,  ::efl::eolian::out_traits<Evas_Coord>::type cy,  ::efl::eolian::out_traits<Evas_Coord>::type cw,  ::efl::eolian::out_traits<Evas_Coord>::type ch) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_TEXT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::evas::Text() const;
   operator ::evas::Text&();
   operator ::evas::Text const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Text,  ::efl::Animator,  ::efl::Gfx,  ::efl::Text,  ::efl::canvas::Object,  ::efl::canvas::filter::Internal,  ::efl::gfx::Filter,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::efl::text::Properties,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Text const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::Text const ,  ::efl::canvas::Object const ,  ::efl::canvas::filter::Internal const ,  ::efl::gfx::Filter const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::efl::text::Properties const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace evas { 
struct Text : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl::Text)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::canvas ::filter::Internal)
   , EO_CXX_INHERIT( ::efl ::gfx::Filter)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::efl ::text::Properties)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Text( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Text(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Text(Text const& other) = default;
   Text(Text&& other) = default;
   Text& operator=(Text const& other) = default;
   Text& operator=(Text&& other) = default;
   Text()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Text( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Text(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   void shadow_color_get( ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   void shadow_color_set( ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   double ellipsis_get() const;
   void ellipsis_set( ::efl::eolian::in_traits<double>::type ellipsis) const;
    ::efl::eina::string_view bidi_delimiters_get() const;
   void bidi_delimiters_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type delim) const;
   void outline_color_get( ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   void outline_color_set( ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   void glow2_color_get( ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   void glow2_color_set( ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   Evas_Text_Style_Type style_get() const;
   void style_set( ::efl::eolian::in_traits<Evas_Text_Style_Type>::type style) const;
   void glow_color_get( ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   void glow_color_set( ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   Evas_Coord max_descent_get() const;
   void style_pad_get( ::efl::eolian::out_traits<int>::type l,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type t,  ::efl::eolian::out_traits<int>::type b) const;
   Efl_Text_Bidirectional_Type direction_get() const;
   Evas_Coord ascent_get() const;
   Evas_Coord horiz_advance_get() const;
   Evas_Coord inset_get() const;
   Evas_Coord max_ascent_get() const;
   Evas_Coord vert_advance_get() const;
   Evas_Coord descent_get() const;
   int last_up_to_pos( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   int char_coords_get( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<Evas_Coord>::type cx,  ::efl::eolian::out_traits<Evas_Coord>::type cy,  ::efl::eolian::out_traits<Evas_Coord>::type cw,  ::efl::eolian::out_traits<Evas_Coord>::type ch) const;
   bool char_pos_get( ::efl::eolian::in_traits<int>::type pos,  ::efl::eolian::out_traits<Evas_Coord>::type cx,  ::efl::eolian::out_traits<Evas_Coord>::type cy,  ::efl::eolian::out_traits<Evas_Coord>::type cw,  ::efl::eolian::out_traits<Evas_Coord>::type ch) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_TEXT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Text,  ::efl::Animator,  ::efl::Gfx,  ::efl::Text,  ::efl::canvas::Object,  ::efl::canvas::filter::Internal,  ::efl::gfx::Filter,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::efl::text::Properties,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Text const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::Text const ,  ::efl::canvas::Object const ,  ::efl::canvas::filter::Internal const ,  ::efl::gfx::Filter const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::efl::text::Properties const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Text) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Text>::value, "");
} 
#include "evas_text.eo.impl.hh"
#endif
